/*	Renegade Scripts.dll
	Copyright 2011 Tiberian Technologies

	This file is part of the Renegade scripts.dll
	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
	the terms of the GNU General Public License as published by the Free
	Software Foundation; either version 2, or (at your option) any later
	version. See the file COPYING for more details.
	In addition, an exemption is given to allow Run Time Dynamic Linking of this code with any closed source module that does not contain code covered by this licence.
	Only the source code to the module(s) containing the licenced code has to be released.
*/
#ifndef TT_INCLUDE_TRANSITIONGAMEOBJ_H
#define TT_INCLUDE_TRANSITIONGAMEOBJ_H
#include "BaseGameObj.h"
#include "engine_vector.h"
#include "TransitionInstanceClass.h"
#include "Matrix3D.h"
class TransitionGameObjDef;
class TransitionGameObj : public BaseGameObj {
private:
	DynamicVectorClass<TransitionInstanceClass *> Transitions;
	Matrix3D Transform;
	int LadderIndex;
public:
	TransitionGameObj();
	~TransitionGameObj();
	void On_Post_Load();
	const PersistFactoryClass &Get_Factory() const;
	bool Save(ChunkSaveClass &csave);
	bool Load(ChunkLoadClass &cload);
	void Init();
	void Init(const TransitionGameObjDef &definition);
	const TransitionGameObjDef & Get_Definition( void ) const ;
	void Set_Transform(const Matrix3D &tm);
	const Matrix3D &Get_Transform() const;
	DynamicVectorClass<TransitionInstanceClass *> &Get_Transitions() {return Transitions;}
	const DynamicVectorClass<TransitionInstanceClass *> &Get_Transitions() const {return Transitions;}
	void Create_Transitions();
	void Destroy_Transitions();
};

#endif
