/*	Renegade Scripts.dll
	Copyright 2011 Tiberian Technologies

	This file is part of the Renegade scripts.dll
	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
	the terms of the GNU General Public License as published by the Free
	Software Foundation; either version 2, or (at your option) any later
	version. See the file COPYING for more details.
	In addition, an exemption is given to allow Run Time Dynamic Linking of this code with any closed source module that does not contain code covered by this licence.
	Only the source code to the module(s) containing the licenced code has to be released.
*/
#ifndef SCRIPTS_INCLUDE__ENGINE_GAME_H
#define SCRIPTS_INCLUDE__ENGINE_GAME_H
#include "GameData.h"

void SCRIPTS_API Power_Base(int team,bool powered); //Power a base up or down, correctly handles the doubled build time and costs
void SCRIPTS_API Set_Can_Generate_Soldiers(int team,bool cangenerate); //Sets if soliders are purchasable
void SCRIPTS_API Set_Can_Generate_Vehicles(int team,bool cangenerate); //Sets if vehicles are purchaseable
void SCRIPTS_API Destroy_Base(int team); //Destroys a base completly
void SCRIPTS_API Beacon_Destroyed_Base(int team, bool destroyed); //Sets if a base was destroyed by a beacon in the beacon zone
void SCRIPTS_API Enable_Base_Radar(int team, bool enable); //Enables radar for a base, same thing as the communications center does
bool SCRIPTS_API Is_Harvester(GameObject *obj); //Is this object one of the 2 team AI harvesters?
bool SCRIPTS_API Is_Radar_Enabled(int team); //returns if the radar is enabled
int SCRIPTS_API Building_Type(GameObject *obj); //returns the type of a BuildingGameObj
bool SCRIPTS_API Is_Building_Dead(GameObject *obj); //Does the game consider the building dead
GameObject SCRIPTS_API *Find_Building(int team,int type); //Find a building by team and type
GameObject SCRIPTS_API *Find_Base_Defense(int team); //Find base defense for a team
bool SCRIPTS_API Is_Map_Flying(); //Is the current map a flying map
GameObject SCRIPTS_API *Create_Building(const char *preset,const Vector3 & Position); //Create a building controller
GameObject SCRIPTS_API *Find_Harvester(int team); //Find this teams current harvester, if any
bool SCRIPTS_API Is_Base_Powered(int team); //Is this teams base powered
bool SCRIPTS_API Can_Generate_Vehicles(int team); //Can this team buy vehicles
bool SCRIPTS_API Can_Generate_Soliders(int team); //Can this team buy soldiers
cGameData SCRIPTS_API *The_Game(); //get the cGameData
cGameDataSkirmish SCRIPTS_API *The_Skirmish_Game(); //get the cGameDataSkirmish
cGameDataCnc SCRIPTS_API *The_Cnc_Game(); //get the cGameDataCnc
cGameDataSinglePlayer SCRIPTS_API *The_Single_Player_Game(); //get the cGameDataSinglePlayer
bool SCRIPTS_API Is_A_Building(GameObject *obj); //is this object any building type
int SCRIPTS_API Get_Building_Count_Team(int Team); //number of buildings a team has that are alive
GameObject SCRIPTS_API *Find_Building_By_Team(int Team); //finds the first building of this team,0 = Nod,1 = GDI
GameObject SCRIPTS_API *Find_Building_By_Name(int Team,const char *Preset_Name); //finds the first building of team where preset name matches name,0 = Nod,1 = GDI
GameObject SCRIPTS_API *Find_Power_Plant(int Team); //finds the first powerplant for Team,0 = Nod,1 = GDI,2 = either
GameObject SCRIPTS_API *Find_Construction_Yard(int Team); //finds the first construction yard for Team,0 = Nod,1 = GDI,2 = either
GameObject SCRIPTS_API *Find_Refinery(int Team); //finds the first refinery for Team,0 = Nod,1 = GDI,2 = either
GameObject SCRIPTS_API *Find_Repair_Bay(int Team); //finds the first repair bay for Team,0 = Nod,1 = GDI,2 = either
GameObject SCRIPTS_API *Find_Soldier_Factory(int Team); //finds the first soldier factory for Team,0 = Nod,1 = GDI,2 = either
GameObject SCRIPTS_API *Find_Airstrip(int Team); //finds the first airstrip for Team,0 = Nod,1 = GDI,2 = either
GameObject SCRIPTS_API *Find_War_Factory(int Team); //finds the first war factory for Team,0 = Nod,1 = GDI,2 = either
GameObject SCRIPTS_API *Find_Vehicle_Factory(int Team); //finds the first airstrip for Team,if none is found,finds the first war factory for Team,0 = Nod,1 = GDI,2 = either
GameObject SCRIPTS_API *Find_Com_Center(int Team); //finds the first communications center for Team,0 = Nod,1 = GDI,2 = either
void SCRIPTS_API Restore_Building(GameObject* obj); //restores a building to life
bool SCRIPTS_API Is_Gameplay_Permitted(); //is gameplay permitted
bool SCRIPTS_API Is_Dedicated(); //returns false if game.exe, true if WFDS/LFDS
unsigned int SCRIPTS_API Get_Current_Game_Mode(); //Get the current game mode, 0 = function error, 1 = single player, 2 = skirmish, 3 = WOL, 4 = GameSpy, 5 = LAN. May not always differentiate correctly between WOL, Gamespy and LAN, especially when running as a non-dedicated server.
void SCRIPTS_API Get_Private_Message_Color(unsigned int *red, unsigned int *green, unsigned int *blue); //get color for private messages
void SCRIPTS_API Get_Public_Message_Color(unsigned int *red, unsigned int *green, unsigned int *blue); //get color for public messages
int SCRIPTS_API Get_Harvester_Preset_ID(int Team); //Get the harvester preset ID for this team
bool SCRIPTS_API Is_Harvester_Preset(GameObject *obj); //Checks if the object has the same preset used for the harvesters
bool SHADERS_API Is_Night_Map(); //is the current map a nighttime map
#endif
