/*	Renegade Scripts.dll
	Copyright 2011 Tiberian Technologies

	This file is part of the Renegade scripts.dll
	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
	the terms of the GNU General Public License as published by the Free
	Software Foundation; either version 2, or (at your option) any later
	version. See the file COPYING for more details.
	In addition, an exemption is given to allow Run Time Dynamic Linking of this code with any closed source module that does not contain code covered by this licence.
	Only the source code to the module(s) containing the licenced code has to be released.
*/
#include "general.h"

#include "PowerUpGameObjDef.h"
#include "PowerUpGameObj.h"
#include "scripts.h"
#include "BuildingGameObj.h"
#include "GameObjManager.h"
#include "wwmath.h"
#include "VehicleGameObj.h"
#include "SoldierGameObj.h"
#include "engine_def.h"
#include "RefineryGameObj.h"
#include "ScriptZoneGameObj.h"
#include "MoveablePhysClass.h"
#include "SmartGameObjDef.h"
#include "VehicleFactoryGameObj.h"
#include "VehicleFactoryGameObjDef.h"
#include "TransitionGameObjDef.h"
#include "AirFactoryGameObjDef.h"
#include "AirFactoryGameObj.h"
#include "AirStripGameObjDef.h"
#include "AirStripGameObj.h"
#include "BeaconGameObjDef.h"
#include "BeaconGameObj.h"
#include "C4GameObjDef.h"
#include "C4GameObj.h"
#include "CinematicGameObjDef.h"
#include "CinematicGameObj.h"
#include "ComCenterGameObjDef.h"
#include "ComCenterGameObj.h"
#include "ConstructionYardGameObjDef.h"
#include "ConstructionYardGameObj.h"
#include "DamageZoneGameObjDef.h"
#include "DamageZoneGameObj.h"
#include "PowerPlantGameObjDef.h"
#include "PowerPlantGameObj.h"
#include "RepairBayGameObjDef.h"
#include "RepairBayGameObj.h"
#include "SamSiteGameObjDef.h"
#include "SamSiteGameObj.h"
#include "SoldierFactoryGameObjDef.h"
#include "SoldierFactoryGameObj.h"
#include "SpecialEffectsGameObjDef.h"
#include "SpecialEffectsGameObj.h"
#include "TransitionGameObjDef.h"
#include "TransitionGameObj.h"
#include "WarFactoryGameObjDef.h"
#include "WarFactoryGameObj.h"

const AirFactoryGameObjDef &
AirFactoryGameObj::Get_Definition (void) const
{
	return (const AirFactoryGameObjDef &)BaseGameObj::Get_Definition ();
}
const AirStripGameObjDef & AirStripGameObj::Get_Definition( void ) const
{
	return (const AirStripGameObjDef &)BaseGameObj::Get_Definition();
}
const ArmedGameObjDef & ArmedGameObj::Get_Definition( void ) const
{
	return (const ArmedGameObjDef &)BaseGameObj::Get_Definition();
}
const BeaconGameObjDef & BeaconGameObj::Get_Definition( void ) const
{
	return (const BeaconGameObjDef &)BaseGameObj::Get_Definition();
}
const C4GameObjDef & C4GameObj::Get_Definition( void ) const
{
	return (const C4GameObjDef &)BaseGameObj::Get_Definition();
}
const CinematicGameObjDef & CinematicGameObj::Get_Definition( void ) const
{
	return (const CinematicGameObjDef &)BaseGameObj::Get_Definition();
}
const ComCenterGameObjDef &
ComCenterGameObj::Get_Definition (void) const
{
	return (const ComCenterGameObjDef &)BaseGameObj::Get_Definition ();
}
const ConstructionYardGameObjDef &
ConstructionYardGameObj::Get_Definition (void) const
{
	return (const ConstructionYardGameObjDef &)BaseGameObj::Get_Definition ();
}
const DamageZoneGameObjDef & DamageZoneGameObj::Get_Definition( void ) const
{
	return (const DamageZoneGameObjDef &)BaseGameObj::Get_Definition();
}
const PowerPlantGameObjDef &
PowerPlantGameObj::Get_Definition (void) const
{
	return (const PowerPlantGameObjDef &)BaseGameObj::Get_Definition ();
}
const RepairBayGameObjDef &
RepairBayGameObj::Get_Definition (void) const
{
	return (const RepairBayGameObjDef &)BaseGameObj::Get_Definition ();
}
const SamSiteGameObjDef & SamSiteGameObj::Get_Definition( void ) const
{
	return (const SamSiteGameObjDef &)BaseGameObj::Get_Definition();
}
const SoldierGameObjDef & SoldierGameObj::Get_Definition( void ) const
{
	return (const SoldierGameObjDef &)BaseGameObj::Get_Definition();
}
const SoldierFactoryGameObjDef &
SoldierFactoryGameObj::Get_Definition (void) const
{
	return (const SoldierFactoryGameObjDef &)BaseGameObj::Get_Definition ();
}
const SpecialEffectsGameObjDef & SpecialEffectsGameObj::Get_Definition( void ) const
{
	return (const SpecialEffectsGameObjDef &)BaseGameObj::Get_Definition();
}
const TransitionGameObjDef & TransitionGameObj::Get_Definition( void ) const
{
	return (const TransitionGameObjDef &)BaseGameObj::Get_Definition();
}
const WarFactoryGameObjDef &
WarFactoryGameObj::Get_Definition (void) const
{
	return (const WarFactoryGameObjDef &)BaseGameObj::Get_Definition ();
}

const VehicleFactoryGameObjDef &
VehicleFactoryGameObj::Get_Definition (void) const
{
	return (const VehicleFactoryGameObjDef &)BaseGameObj::Get_Definition ();
}

const ScriptZoneGameObjDef & ScriptZoneGameObj::Get_Definition( void ) const
{
	return (const ScriptZoneGameObjDef &)BaseGameObj::Get_Definition();
}

unsigned char NetworkObjectClass::Get_Object_Dirty_Bits(int clientId)
{
	return ClientStatus[clientId];
}

bool NetworkObjectClass::Get_Object_Dirty_Bit(int clientId, DIRTY_BIT level)
{
	return (ClientStatus[clientId] & level) == level;
}

void DefenseObjectClass::Set_Health_Max(float health)
{
	HealthMax = WWMath::Clamp(health, 0, MAX_MAX_HEALTH);
	if (HealthMax < Health)
	{
		Health = HealthMax;
	}
	Mark_Owner_Dirty();
}

void	DefenseObjectClass::Set_Shield_Type( ArmorType type )	
{ 
	ShieldType = type; 
	Mark_Owner_Dirty();
}

float DefenseObjectClass::Get_Health() const
{
	return this->Health;
}



float DefenseObjectClass::Get_Health_Max() const
{
	return this->HealthMax;
}


float DefenseObjectClass::Get_Shield_Strength() const
{
	return this->ShieldStrength;
}



float DefenseObjectClass::Get_Shield_Strength_Max() const
{
	return this->ShieldStrengthMax;
}

void DefenseObjectClass::Set_Shield_Strength_Max(float str)
{
	ShieldStrengthMax = WWMath::Clamp(str, 0, MAX_MAX_SHIELD_STRENGTH);
	if (ShieldStrengthMax < ShieldStrength)
	{
		ShieldStrength = ShieldStrengthMax;
	}
	Mark_Owner_Dirty();
}



void DefenseObjectClass::Mark_Owner_Dirty()
{
	if (Get_Owner())
	{
		Get_Owner()->Set_Object_Dirty_Bit(NetworkObjectClass::BIT_OCCASIONAL, true);
	}
}

SCRIPTS_API REF_DEF3(GameObjManager::BuildingGameObjList, SList<BuildingGameObj>, 0x00856FE8, 0x008561D0, 0x0085BED0);
SCRIPTS_API REF_DEF3(GameObjManager::GameObjList, SList<BaseGameObj>, 0x00856FF8, 0x008561E0, 0x0085BEE0);
SCRIPTS_API REF_DEF3(GameObjManager::StarGameObjList, SList<SoldierGameObj>, 0x00856FC8, 0x008561B0, 0x0085BEB0);
SCRIPTS_API REF_DEF3(GameObjManager::SmartGameObjList, SList<SmartGameObj>, 0x00856FD8, 0x008561C0, 0x0085BEC0);

#ifdef SHADERS_EXPORTS
SHADERS_API SList<C4GameObj> GameObjManager::C4GameObjList;
SHADERS_API SList<BeaconGameObj> GameObjManager::BeaconGameObjList;
#endif

const BaseGameObjDef &	BaseGameObj::Get_Definition( void ) const 
{
	return *Definition;
};

const DamageableGameObjDef & DamageableGameObj::Get_Definition( void ) const 
{
	return (const DamageableGameObjDef &)BaseGameObj::Get_Definition();
}

void ScriptableGameObj::Insert_Observer( GameObjObserverClass * observer )
{
	observer->Attach( this );
	Observers.Add( observer );
}

void ScriptableGameObj::Remove_Observer( GameObjObserverClass * observer )
{
	Observers.Delete( observer );
	observer->Detach( this );
}

const ScriptableGameObjDef & ScriptableGameObj::Get_Definition( void ) const
{
	return (const ScriptableGameObjDef &)BaseGameObj::Get_Definition();
}

const BuildingGameObjDef & BuildingGameObj::Get_Definition( void ) const
{
	return (const BuildingGameObjDef &)BaseGameObj::Get_Definition();
}

const RefineryGameObjDef & RefineryGameObj::Get_Definition( void ) const
{
	return (const RefineryGameObjDef &)BaseGameObj::Get_Definition();
}

#ifndef TTLE_EXPORTS
#ifndef TT_EXPORTS
RENEGADE_FUNCTION
bool PowerUpGameObjDef::Grant(SmartGameObj *, PowerUpGameObj *, bool) const
AT2(0x006F09F0,0x006EFFB0);
#endif

RENEGADE_FUNCTION
Vector3 SCRIPTS_API Get_Color_For_Team(int teamId)
AT2(0x006D99E0,0x006D9280);
Vector3 DamageableGameObj::Get_Team_Color(void)
{
	return Get_Color_For_Team(PlayerType);
}

int SCRIPTS_API Get_Object_Type(GameObject *obj)
{
	if (!obj || !Commands->Get_ID(obj))
	{
		return 0;
	}
	ScriptableGameObj *o = ((BaseGameObj*)obj)->As_ScriptableGameObj();
	if(!o)
	{
		return 0;
	}
	DamageableGameObj *o2 = o->As_DamageableGameObj();
	if (!o2)
	{
		return 0;
	}
	return o2->Get_Player_Type();
}

void SCRIPTS_API Set_Object_Type(GameObject *obj,int type)
{
	if (!obj || !Commands->Get_ID(obj))
	{
		return;
	}
	ScriptableGameObj *o = ((BaseGameObj*)obj)->As_ScriptableGameObj();
	if(!o)
	{
		return;
	}
	DamageableGameObj *o2 = o->As_DamageableGameObj();
	if (!o2)
	{
		return;
	}
	o2->Set_Player_Type(type);
}

GameObject SCRIPTS_API *As_PowerUpGameObj(GameObject *obj)
{
	if (!obj || !Commands->Get_ID(obj))
	{
		return 0;
	}
	PhysicalGameObj *o2 = ((BaseGameObj *)obj)->As_PhysicalGameObj();
	if (!o2)
	{
		return 0;
	}
	return (GameObject *)o2->As_PowerUpGameObj();
}

GameObject SCRIPTS_API *As_C4GameObj(GameObject *obj)
{
	if (!obj || !Commands->Get_ID(obj))
	{
		return 0;
	}
	PhysicalGameObj *o2 = ((BaseGameObj *)obj)->As_PhysicalGameObj();
	if (!o2)
	{
		return 0;
	}
	return (GameObject *)o2->As_C4GameObj();
}

GameObject SCRIPTS_API *As_BeaconGameObj(GameObject *obj)
{
	if (!obj || !Commands->Get_ID(obj))
	{
		return 0;
	}
	PhysicalGameObj *o2 = ((BaseGameObj *)obj)->As_PhysicalGameObj();
	if (!o2)
	{
		return 0;
	}
	return (GameObject *)o2->As_BeaconGameObj();
}

GameObject SCRIPTS_API *As_ArmedGameObj(GameObject *obj)
{
	if (!obj || !Commands->Get_ID(obj))
	{
		return 0;
	}
	PhysicalGameObj *o2 = ((BaseGameObj *)obj)->As_PhysicalGameObj();
	if (!o2)
	{
		return 0;
	}
	return (GameObject *)o2->As_ArmedGameObj();
}

GameObject SCRIPTS_API *As_SimpleGameObj(GameObject *obj)
{
	if (!obj || !Commands->Get_ID(obj))
	{
		return 0;
	}
	PhysicalGameObj *o2 = ((BaseGameObj *)obj)->As_PhysicalGameObj();
	if (!o2)
	{
		return 0;
	}
	return (GameObject *)o2->As_SimpleGameObj();
}

GameObject SCRIPTS_API *As_PowerPlantGameObj(GameObject *obj)
{
	if (!obj || !Commands->Get_ID(obj))
	{
		return 0;
	}
	ScriptableGameObj *o = ((BaseGameObj*)obj)->As_ScriptableGameObj();
	if(!o)
	{
		return 0;
	}
	BuildingGameObj *o2 = o->As_BuildingGameObj();
	if (!o2)
	{
		return 0;
	}
	return (GameObject *)o2->As_PowerPlantGameObj();
}

GameObject SCRIPTS_API *As_ConstructionYardGameObj(GameObject *obj)
{
	if (!obj || !Commands->Get_ID(obj))
	{
		return 0;
	}
	ScriptableGameObj *o = ((BaseGameObj*)obj)->As_ScriptableGameObj();
	if(!o)
	{
		return 0;
	}
	BuildingGameObj *o2 = o->As_BuildingGameObj();
	if (!o2)
	{
		return 0;
	}
	return (GameObject *)o2->As_ConstructionYardGameObj();
}

GameObject SCRIPTS_API *As_SoldierFactoryGameObj(GameObject *obj)
{
	if (!obj || !Commands->Get_ID(obj))
	{
		return 0;
	}
	ScriptableGameObj *o = ((BaseGameObj*)obj)->As_ScriptableGameObj();
	if(!o)
	{
		return 0;
	}
	BuildingGameObj *o2 = o->As_BuildingGameObj();
	if (!o2)
	{
		return 0;
	}
	return (GameObject *)o2->As_SoldierFactoryGameObj();
}

GameObject SCRIPTS_API *As_VehicleFactoryGameObj(GameObject *obj)
{
	if (!obj || !Commands->Get_ID(obj))
	{
		return 0;
	}
	ScriptableGameObj *o = ((BaseGameObj*)obj)->As_ScriptableGameObj();
	if(!o)
	{
		return 0;
	}
	BuildingGameObj *o2 = o->As_BuildingGameObj();
	if (!o2)
	{
		return 0;
	}
	return (GameObject *)o2->As_VehicleFactoryGameObj();
}

GameObject SCRIPTS_API *As_AirstripGameObj(GameObject *obj)
{
	if (!obj || !Commands->Get_ID(obj))
	{
		return 0;
	}
	ScriptableGameObj *o = ((BaseGameObj*)obj)->As_ScriptableGameObj();
	if(!o)
	{
		return 0;
	}
	BuildingGameObj *o2 = o->As_BuildingGameObj();
	if (!o2)
	{
		return 0;
	}
	return (GameObject *)o2->As_AirStripGameObj();
}

GameObject SCRIPTS_API *As_WarFactoryGameObj(GameObject *obj)
{
	if (!obj || !Commands->Get_ID(obj))
	{
		return 0;
	}
	ScriptableGameObj *o = ((BaseGameObj*)obj)->As_ScriptableGameObj();
	if(!o)
	{
		return 0;
	}
	BuildingGameObj *o2 = o->As_BuildingGameObj();
	if (!o2)
	{
		return 0;
	}
	return (GameObject *)o2->As_WarFactoryGameObj();
}

GameObject SCRIPTS_API *As_RefineryGameObj(GameObject *obj)
{
	if (!obj || !Commands->Get_ID(obj))
	{
		return 0;
	}
	ScriptableGameObj *o = ((BaseGameObj*)obj)->As_ScriptableGameObj();
	if(!o)
	{
		return 0;
	}
	BuildingGameObj *o2 = o->As_BuildingGameObj();
	if (!o2)
	{
		return 0;
	}
	return (GameObject *)o2->As_RefineryGameObj();
}

GameObject SCRIPTS_API *As_ComCenterGameObj(GameObject *obj)
{
	if (!obj || !Commands->Get_ID(obj))
	{
		return 0;
	}
	ScriptableGameObj *o = ((BaseGameObj*)obj)->As_ScriptableGameObj();
	if(!o)
	{
		return 0;
	}
	BuildingGameObj *o2 = o->As_BuildingGameObj();
	if (!o2)
	{
		return 0;
	}
	return (GameObject *)o2->As_ComCenterGameObj();
}

GameObject SCRIPTS_API *As_RepairBayGameObj(GameObject *obj)
{
	if (!obj || !Commands->Get_ID(obj))
	{
		return 0;
	}
	ScriptableGameObj *o = ((BaseGameObj*)obj)->As_ScriptableGameObj();
	if(!o)
	{
		return 0;
	}
	BuildingGameObj *o2 = o->As_BuildingGameObj();
	if (!o2)
	{
		return 0;
	}
	return (GameObject *)o2->As_RepairBayGameObj();
}

GameObject SCRIPTS_API *As_ScriptableGameObj(GameObject *obj)
{
	if (!obj || !Commands->Get_ID(obj))
	{
		return 0;
	}
	return (GameObject *)((BaseGameObj *)obj)->As_ScriptableGameObj();
}

GameObject SCRIPTS_API *As_PhysicalGameObj(GameObject *obj)
{
	if (!obj || !Commands->Get_ID(obj))
	{
		return 0;
	}
	return (GameObject *)((BaseGameObj *)obj)->As_PhysicalGameObj();
}

GameObject SCRIPTS_API *As_CinematicGameObj(GameObject *obj)
{
	if (!obj || !Commands->Get_ID(obj))
	{
		return 0;
	}
	PhysicalGameObj *o2 = ((BaseGameObj *)obj)->As_PhysicalGameObj();
	if (!o2)
	{
		return 0;
	}
	return (GameObject *)o2->As_CinematicGameObj();
}

GameObject SCRIPTS_API *As_VehicleGameObj(GameObject *obj)
{
	if (!obj || !Commands->Get_ID(obj))
	{
		return 0;
	}
	return (GameObject *)((BaseGameObj *)obj)->As_VehicleGameObj();
}

GameObject SCRIPTS_API *As_SmartGameObj(GameObject *obj)
{
	if (!obj || !Commands->Get_ID(obj))
	{
		return 0;
	}
	return (GameObject *)((BaseGameObj *)obj)->As_SmartGameObj();
}

GameObject SCRIPTS_API *As_DamageableGameObj(GameObject *obj)
{
	if (!obj || !Commands->Get_ID(obj))
	{
		return 0;
	}
	ScriptableGameObj* o2 = ((BaseGameObj *)obj)->As_ScriptableGameObj();
	if(!o2)
	{
		return 0;
	}
	return (GameObject *)o2->As_DamageableGameObj();
}

GameObject SCRIPTS_API *As_SoldierGameObj(GameObject *obj)
{
	if (!obj || !Commands->Get_ID(obj))
	{
		return 0;
	}
	ScriptableGameObj* o2 = ((BaseGameObj *)obj)->As_ScriptableGameObj();
	if(!o2)
	{
		return 0;
	}
	return (GameObject *)o2->As_SoldierGameObj();
}

GameObject SCRIPTS_API *As_ScriptZoneGameObj(GameObject *obj)
{
	if (!obj || !Commands->Get_ID(obj))
	{
		return 0;
	}
	ScriptableGameObj* o2 = ((BaseGameObj *)obj)->As_ScriptableGameObj();
	if(!o2)
	{
		return 0;
	}
	return (GameObject *)o2->As_ScriptZoneGameObj();
}

GameObject SCRIPTS_API *As_BuildingGameObj(GameObject *obj)
{
	if (!obj || !Commands->Get_ID(obj))
	{
		return 0;
	}
	ScriptableGameObj* o2 = ((BaseGameObj *)obj)->As_ScriptableGameObj();
	if(!o2)
	{
		return 0;
	}
	return (GameObject *)o2->As_BuildingGameObj();
}

bool SCRIPTS_API Is_Building(GameObject *obj)
{
	if (As_BuildingGameObj(obj))
	{
		return true;
	}
	return false;
}

bool SCRIPTS_API Is_Soldier(GameObject *obj)
{
	if (As_SoldierGameObj(obj))
	{
		return true;
	}
	return false;
}

bool SCRIPTS_API Is_Vehicle(GameObject *obj)
{
	if (As_VehicleGameObj(obj))
	{
		return true;
	}
	return false;
}

bool SCRIPTS_API Is_Cinematic(GameObject *obj)
{
	if (As_CinematicGameObj(obj))
	{
		return true;
	}
	return false;
}

bool SCRIPTS_API Is_ScriptZone(GameObject *obj)
{
	if (As_ScriptZoneGameObj(obj))
	{
		return true;
	}
	return false;
}

bool SCRIPTS_API Is_Powerup(GameObject *obj)
{
	if (As_PowerUpGameObj(obj))
	{
		return true;
	}
	return false;
}

bool SCRIPTS_API Is_C4(GameObject *obj)
{
	if (As_C4GameObj(obj))
	{
		return true;
	}
	return false;
}

bool SCRIPTS_API Is_Scriptable(GameObject *obj)
{
	if (As_ScriptableGameObj(obj))
	{
		return true;
	}
	return false;
}

bool SCRIPTS_API Is_Beacon(GameObject *obj)
{
	if (As_BeaconGameObj(obj))
	{
		return true;
	}
	return false;
}

bool SCRIPTS_API Is_Armed(GameObject *obj)
{
	if (As_ArmedGameObj(obj))
	{
		return true;
	}
	return false;
}

bool SCRIPTS_API Is_Simple(GameObject *obj)
{
	if (As_SimpleGameObj(obj))
	{
		return true;
	}
	return false;
}

bool SCRIPTS_API Is_PowerPlant(GameObject *obj)
{
	if (As_PowerPlantGameObj(obj))
	{
		return true;
	}
	return false;
}

bool SCRIPTS_API Is_ConstructionYard(GameObject *obj)
{
	if (As_ConstructionYardGameObj(obj))
	{
		return true;
	}
	return false;
}

bool SCRIPTS_API Is_SoldierFactory(GameObject *obj)
{
	if (As_SoldierFactoryGameObj(obj))
	{
		return true;
	}
	return false;
}

bool SCRIPTS_API Is_VehicleFactory(GameObject *obj)
{
	if (As_VehicleFactoryGameObj(obj))
	{
		return true;
	}
	return false;
}

bool SCRIPTS_API Is_Airstrip(GameObject *obj)
{
	if (As_AirstripGameObj(obj))
	{
		return true;
	}
	return false;
}

bool SCRIPTS_API Is_WarFactory(GameObject *obj)
{
	if (As_WarFactoryGameObj(obj))
	{
		return true;
	}
	return false;
}

bool SCRIPTS_API Is_Refinery(GameObject *obj)
{
	if (As_RefineryGameObj(obj))
	{
		return true;
	}
	return false;
}

bool SCRIPTS_API Is_ComCenter(GameObject *obj)
{
	if (As_ComCenterGameObj(obj))
	{
		return true;
	}
	return false;
}

bool SCRIPTS_API Is_RepairBay(GameObject *obj)
{
	if (As_RepairBayGameObj(obj))
	{
		return true;
	}
	return false;
}

const char SCRIPTS_API *Get_Building_Type(GameObject *obj)
{
	if (Is_PowerPlant(obj))
	{
		return "Is_PowerPlant";
	}
	else if (Is_ConstructionYard(obj))
	{
		return "Is_ConstructionYard";
	}
	else if (Is_SoldierFactory(obj))
	{
		return "Is_SoldierFactory";
	}
	else if (Is_VehicleFactory(obj))
	{
		if (Is_Airstrip(obj))
		{
			return "Is_Airstrip";
		}
		else if (Is_WarFactory(obj))
		{
			return "Is_WarFactory";
		}
	}
	else if (Is_Refinery(obj))
	{
		return "Is_Refinery";
	}
	else if (Is_ComCenter(obj))
	{
		return "Is_ComCenter";
	}
	else if (Is_RepairBay(obj))
	{
		return "Is_RepairBay";
	}
	else
	{
		return "(null)";
	}
	return "(null)";
}

void SCRIPTS_API Get_Object_Color(GameObject *obj, unsigned int *red, unsigned int *green, unsigned int *blue)
{
	if (!obj || !Commands->Get_ID(obj))
	{
		return;
	}
	DamageableGameObj *o = (DamageableGameObj *)As_DamageableGameObj(obj);
	if (!o)
	{
		return;
	}
	Vector3 v = o->Get_Team_Color();
	*red = (unsigned int)(v.X*255);
	*green = (unsigned int)(v.Y*255);
	*blue = (unsigned int)(v.Z*255);
}

GameObject SCRIPTS_API *Find_Smart_Object_By_Team(int Team)
{
	SLNode<SmartGameObj> *x = GameObjManager::SmartGameObjList.Head();
	while (x)
	{
		GameObject *o = As_SmartGameObj(x->Data());
		if (o)
		{
			if (Get_Object_Type(o) == Team)
			{
				return o;
			}
		}
		x = x->Next();
	}
	return 0;
}

GameObject SCRIPTS_API *Find_Object_By_Team(int Team)
{
	SLNode<BaseGameObj> *x = GameObjManager::GameObjList.Head();
	while (x)
	{
		GameObject *o = (GameObject *)x->Data();
		if (o && As_ScriptableGameObj(o))
		{
			if (Get_Object_Type(o) == Team)
			{
				return o;
			}
		}
		x = x->Next();
	}
	return 0;
}

GameObject SCRIPTS_API *Find_Non_Player_Object_By_Team(int Team)
{
	SLNode<SmartGameObj> *x = GameObjManager::SmartGameObjList.Head();
	while (x)
	{
		GameObject *o = As_SmartGameObj(x->Data());
		if (o)
		{
			if ((Get_Object_Type(o) == Team) && (!Commands->Is_A_Star(o)))
			{
				return o;
			}
		}
		x = x->Next();
	}
	return 0;
}

GameObject SCRIPTS_API *Find_Object_By_Preset(int Team,const char *Preset_Name)
{
	SLNode<BaseGameObj> *x = GameObjManager::GameObjList.Head();
	while (x)
	{
		GameObject *o = (GameObject *)x->Data();
		if (o && As_ScriptableGameObj(o))
		{
			const DefinitionClass *d = Get_Definition(o);
			if (!_stricmp(d->Get_Name(),Preset_Name))
			{
				if ((Get_Object_Type(o) == Team) || (Team == 2))
				{
					return o;
				}
			}
		}
		x = x->Next();
	}
	return 0;
}

GameObject SCRIPTS_API *Find_Closest_Non_Building_Object_By_Team(int Team,Vector3 position)
{
	float closestdist = FLT_MAX;
	GameObject *closest = 0;
	SLNode<BaseGameObj> *x = GameObjManager::GameObjList.Head();
	while (x)
	{
		GameObject *o = (GameObject *)x->Data();
		if (o && As_ScriptableGameObj(o))
		{
			if ((Get_Object_Type(o) == Team) && !Is_Building(o))
			{
				Vector3 pos = Commands->Get_Position(o);
				float dist = Commands->Get_Distance(pos,position);
				if (dist < closestdist)
				{
					closestdist = dist;
					closest = o;
				}
			}
		}
		x = x->Next();
	}
	return closest;
}

GameObject SCRIPTS_API *Find_Closest_Preset_By_Team(int Team,const Vector3 &pos,const char *Preset)
{
	float closestdist = 9999.0f;
	GameObject *closest = 0;
	SLNode<BaseGameObj> *x = GameObjManager::GameObjList.Head();
	while (x)
	{
		GameObject *o = (GameObject *)x->Data();
		if (o && As_ScriptableGameObj(o))
		{
			if ((Get_Object_Type(o) == Team || Team == 2) && !_stricmp(Commands->Get_Preset_Name(o),Preset))
			{
				float dist = Commands->Get_Distance(Commands->Get_Position(o),pos);
				if (dist < closestdist)
				{
					closestdist = dist;
					closest = o;
				}
			}
		}
		x = x->Next();
	}
	return closest;
}

GameObject SCRIPTS_API *Find_Random_Preset_By_Team(int Team,const char *Preset)
{
	SimpleDynVecClass<GameObject*> ObjList(0);
	SLNode<BaseGameObj> *x = GameObjManager::GameObjList.Head();
	while (x)
	{
		GameObject *o = (GameObject *)x->Data();
		if (o && As_ScriptableGameObj(o))
		{
			if ((Get_Object_Type(o) == Team || Team == 2) && !_stricmp(Commands->Get_Preset_Name(o),Preset))
			{
				ObjList.Add(o);
			}
		}
		x = x->Next();
	}
	int len = ObjList.Count();
	if (len > 1)
	{
		return ObjList[Commands->Get_Random_Int(0,len)];
	}
	else if (!len)
	{
		return 0;
	}
	return ObjList[0];
}

int SCRIPTS_API Get_Object_Count(int Team,const char *Preset)
{
	int count = 0;
	SLNode<SmartGameObj> *x = GameObjManager::SmartGameObjList.Head();
	while (x)
	{
		GameObject *o = x->Data();
		if (o)
		{
			if ((Get_Object_Type(o) == Team || Team == 2) && !_stricmp(Commands->Get_Preset_Name(o),Preset))
			{
				count++;
			}
		}
		x = x->Next();
	}
	return count;
}

SimpleDynVecClass<GameObject*> SCRIPTS_API *Get_All_Objects_By_Preset(int Team,const char *Preset)
{
	SimpleDynVecClass<GameObject*> *ObjList = new SimpleDynVecClass<GameObject*>;
	SLNode<BaseGameObj> *x = GameObjManager::GameObjList.Head();
	while (x)
	{
		GameObject *o = (GameObject *)x->Data();
		if (o && As_ScriptableGameObj(o))
		{
			if ((Get_Object_Type(o) == Team || Team == 2) && !_stricmp(Commands->Get_Preset_Name(o),Preset))
			{
				ObjList->Add(o);
			}
		}
		x = x->Next();
	}
	return ObjList;
}

GameObject SCRIPTS_API *Find_Nearest_Preset(Vector3 position, const char *preset)
{
	GameObject *object = 0;
	SLNode<BaseGameObj> *x = GameObjManager::GameObjList.Head();
	while (x)
	{
		GameObject *o = (GameObject *)x->Data();
		if (o && As_ScriptableGameObj(o))
		{
			if (!_stricmp(Commands->Get_Preset_Name(o),preset))
			{
				if (object)
				{
					Vector3 obj_pos = Commands->Get_Position(object);
					Vector3 o_pos = Commands->Get_Position(o);
					if (Commands->Get_Distance(position, o_pos) < Commands->Get_Distance(position, obj_pos))
					{
						object = o;
					}
				}
				else
				{
					object = o;
				}
			}
		}
		x = x->Next();
	}
	return object;
}

GameObject SCRIPTS_API *Find_Random_Preset(const char* preset, int min, int max)
{
	int count = Commands->Get_Random_Int(min, max);
	GameObject *object = 0;
	SLNode<BaseGameObj> *x = GameObjManager::GameObjList.Head();
	while (count > 0)
	{
		GameObject *o = (GameObject *)x->Data();
		if (o && As_ScriptableGameObj(o))
		{
			if (!_stricmp(Commands->Get_Preset_Name(o),preset))
			{
				object = o;
				count--;
			}
		}
		x = x->Next();
		if (!x)
		{
			if (object)
			{
				x = GameObjManager::GameObjList.Head();
			}
			else
			{
				return object;
			}
		}
	}
	return object;
}

void SCRIPTS_API Send_Custom_To_Team_Buildings(int Team,GameObject *sender,int type,int param,float delay)
{
	if (!Commands->Get_ID(sender) || !sender)
	{
		return;
	}
	SLNode<BuildingGameObj> *x = GameObjManager::BuildingGameObjList.Head();
	while (x)
	{
		GameObject *o = As_BuildingGameObj(x->Data());
		if (o)
		{
			if (Get_Object_Type(o) == Team)
			{
				int ReceiverID = Commands->Get_ID(o);
				int SenderID = Commands->Get_ID(sender);
				if (SenderID != ReceiverID)
				{
					Commands->Send_Custom_Event(sender,o,type,param,delay);
				}
			}
		}
		x = x->Next();
	}
}

void SCRIPTS_API Send_Custom_To_Team_Preset(int Team,const char *PresetName,GameObject *sender,int type,int param,float delay)
{
	if (!Commands->Get_ID(sender) || !sender)
	{
		return;
	}
	SLNode<BaseGameObj> *x = GameObjManager::GameObjList.Head();
	while (x)
	{
		GameObject *o = (GameObject *)x->Data();
		if (o && As_ScriptableGameObj(o))
		{
			if (Get_Object_Type(o) == Team)
			{
				if (!_stricmp(Commands->Get_Preset_Name(o),PresetName))
				{
					Commands->Send_Custom_Event(sender,o,type,param,delay);
				}
			}
		}
		x = x->Next();
	}
}

void SCRIPTS_API Send_Custom_All_Objects_Area(int type,const Vector3 &Position,float Distance,GameObject *sender,int team)
{
	if (!Commands->Get_ID(sender) || !sender)
	{
		return;
	}
	SLNode<BaseGameObj> *x = GameObjManager::GameObjList.Head();
	while (x) 
	{
		GameObject *obj = (GameObject *)x->Data();
		if (obj && As_ScriptableGameObj(obj))
		{
			Vector3 ObjPosition = Commands->Get_Position(obj);
			Vector3 TestPosition = Position;
			ObjPosition.Z = 0;
			TestPosition.Z = 0;
			if ((Commands->Get_Distance(ObjPosition,TestPosition) <= Distance))
			{
				if ((Get_Object_Type(obj) == team) || (team == 2))
				{
					Commands->Send_Custom_Event(sender,obj,type,0,0);
				}
			}
		}
		x = x->Next();
	}
}

void SCRIPTS_API Send_Custom_All_Objects(int type,GameObject *sender,int team)
{
	if (!Commands->Get_ID(sender) || !sender)
	{
		return;
	}
	SLNode<BaseGameObj> *x = GameObjManager::GameObjList.Head();
	while (x) 
	{
		GameObject *obj = (GameObject *)x->Data();
		if (obj && As_ScriptableGameObj(obj))
		{
			if ((Get_Object_Type(obj) == team) || (team == 2))
			{
				Commands->Send_Custom_Event(sender,obj,type,0,0);
			}
		}
		x = x->Next();
	}
}

void SCRIPTS_API Send_Custom_Event_To_Object(GameObject *sender,const char *Preset,int type,int param,float delay)
{
	if (!Commands->Get_ID(sender) || !sender)
	{
		return;
	}
	SLNode<BaseGameObj> *x = GameObjManager::GameObjList.Head();
	while (x)
	{
		GameObject *o = (GameObject *)x->Data();
		if (o && As_ScriptableGameObj(o))
		{
			const DefinitionClass *d = Get_Definition(o);
			if (!_stricmp(d->Get_Name(),Preset))
			{
				Commands->Send_Custom_Event(sender,o,type,param,delay);
			}
		}
		x = x->Next();
	}
}

bool SCRIPTS_API Is_Unit_In_Range(const char *preset,float range,Vector3 location,int team,bool empty)
{
	SLNode<SmartGameObj> *x = GameObjManager::SmartGameObjList.Head();
	while (x)
	{
		GameObject *o = x->Data();
		if (o && As_ScriptableGameObj(o))
		{
			if (Get_Object_Type(o) == team && !_stricmp(Commands->Get_Preset_Name(o),preset))
			{
				Vector3 pos = Commands->Get_Position(o);
				pos.Z = 0;
				location.Z = 0;
				if (Commands->Get_Distance(pos,location) <= range)
				{
					if (As_VehicleGameObj(o) && !empty)
					{
						if (o->As_VehicleGameObj()->Get_Occupant_Count() == 0)
						{
							return false;
						}
						else
						{
							return true;
						}
					}
					else
					{
						return true;
					}
				}
			}
		}
		x = x->Next();
	}
	return false;
}

bool SCRIPTS_API Get_Is_Powerup_Persistant(GameObject *obj)
{
	PowerUpGameObj *o = (PowerUpGameObj *)As_PowerUpGameObj(obj);
	if (!o)
	{
		return 0;
	}
	return o->Get_Definition().Is_Persistant();
}

bool SCRIPTS_API Get_Powerup_Always_Allow_Grant(GameObject *obj)
{
	PowerUpGameObj *o = (PowerUpGameObj *)As_PowerUpGameObj(obj);
	if (!o)
	{
		return 0;
	}
	return o->Get_Definition().Is_Always_Allow_Grant();
}

int SCRIPTS_API Get_Powerup_Grant_Sound(GameObject *obj)
{
	PowerUpGameObj *o = (PowerUpGameObj *)As_PowerUpGameObj(obj);
	if (!o)
	{
		return 0;
	}
	return o->Get_Definition().Get_Grant_Sound();
}

void SCRIPTS_API Grant_Powerup(GameObject *obj,const char *Preset_Name)
{
	if (!obj || !Commands->Get_ID(obj))
	{
		return;
	}
	GameObject *o = As_SmartGameObj(obj);
	if (o)
	{
		PowerUpGameObjDef *def = (PowerUpGameObjDef *)Find_Named_Definition(Preset_Name);
		def->Grant((SmartGameObj *)o,0,true);
	}
}


Vector3 SCRIPTS_API Get_Velocity( GameObject* obj )
{
	Vector3 velocity ( 0.0f, 0.0f, 0.0f );

	if ( obj && obj->As_PhysicalGameObj() )
	{
		MoveablePhysClass* moveable = obj->As_PhysicalGameObj()->Peek_Physical_Object()->As_MoveablePhysClass();
		if (moveable)
			moveable->Get_Velocity(&velocity);
	}

	return velocity;
}


void SCRIPTS_API Set_Velocity( GameObject* obj, Vector3 velocity )
{
	if ( obj && obj->As_PhysicalGameObj() )
	{
		MoveablePhysClass* moveable = obj->As_PhysicalGameObj()->Peek_Physical_Object()->As_MoveablePhysClass();
		if (moveable)
			moveable->Set_Velocity(velocity);
	}
}


Matrix3D SCRIPTS_API Get_Transform( GameObject* obj )
{
	Matrix3D transform(true);

	if ( obj && obj->As_PhysicalGameObj() )
	{
		MoveablePhysClass* moveable = obj->As_PhysicalGameObj()->Peek_Physical_Object()->As_MoveablePhysClass();
		if (moveable)
			transform = moveable->Get_Transform();
	}

	return transform;
}


void SCRIPTS_API Set_Transform( GameObject* obj, Matrix3D transform )
{
	if ( obj && obj->As_PhysicalGameObj() )
	{
		MoveablePhysClass* moveable = obj->As_PhysicalGameObj()->Peek_Physical_Object()->As_MoveablePhysClass();
		if (moveable)
			moveable->Set_Transform(transform);
	}
}


GameObject SCRIPTS_API *Get_Closest_Armed_Object_To_Object( GameObject* obj, int team )
{
	float closestdist = FLT_MAX;
	GameObject *closest = 0;
	Vector3 position = Commands->Get_Position(obj);
	SLNode<BaseGameObj> *x = GameObjManager::GameObjList.Head();
	while (x)
	{
		GameObject *o = (GameObject *)x->Data();
		if (o && As_ScriptableGameObj(o) && o != obj)
		{
			if ((team == 2 || Get_Object_Type(o) == team) && Is_Armed(o))
			{
				Vector3 pos = Commands->Get_Position(o);
				float dist = Commands->Get_Distance(pos,position);
				if (dist < closestdist)
				{
					closestdist = dist;
					closest = o;
				}
			}
		}
		x = x->Next();
	}
	return closest;
}

void SCRIPTS_API Set_Powerup_Always_Allow_Grant(GameObject *obj,bool Grant)
{
	if (!Commands->Get_ID(obj) || !obj)
	{
		return;
	}
	PhysicalGameObj *o2 = ((ScriptableGameObj *)obj)->As_PhysicalGameObj();
	if (!o2)
	{
		return;
	}
	PowerUpGameObj *o3 = o2->As_PowerUpGameObj();
	if (!o3)
	{
		return;
	}
	((PowerUpGameObjDef&)o3->Get_Definition()).AlwaysAllowGrant = Grant;
}



void PhysicalGameObj::Set_Transform(const Matrix3D& mat)
{
	PhysObj->Set_Transform(mat);
}

const Matrix3D &PhysicalGameObj::Get_Transform() const
{
	return PhysObj->Get_Transform();
}

void PhysicalGameObj::Set_Position(const Vector3& position)
{
	const Matrix3D &mat = PhysObj->Get_Transform();
	Matrix3D tm = mat;
	tm.Set_Translation(position);
	PhysObj->Set_Transform(tm);
}

RENEGADE_FUNCTION
void PhysicalGameObj::Post_Think()
AT2(0x006A5770, 0x006A5010);



bool DamageableGameObj::Is_Teammate(DamageableGameObj * p_obj)
{
	return ((p_obj == this) || (Is_Team_Player() && Get_Player_Type() == p_obj->Get_Player_Type()));
}

int SCRIPTS_API VehicleGameObj::Get_Occupant_Count(void)
{
	int count = 0;
	for ( int i = 0; i < SeatOccupants.Length(); i++ ) {
		if ( SeatOccupants[i] != NULL ) {
			count++;
		}
	}
	return count;
}

VehicleGameObj* SoldierGameObj::Get_Profile_Vehicle( void )
{
	if (( Get_State() == HumanStateClass::IN_VEHICLE ) && Vehicle )
	{
		return Vehicle;
	}
	if (( Get_State() == HumanStateClass::TRANSITION ) && ( TransitionCompletionData != NULL ))
	{
		if ( TransitionCompletionData->Type == TransitionDataClass::VEHICLE_ENTER )
		{
			return (VehicleGameObj *)TransitionCompletionData->Vehicle.Get_Ptr();
		}
	}
	return NULL;
}

bool DamageableGameObj::Is_Team_Player(void) 
{
	int player_type = Get_Player_Type();
	return player_type == PLAYERTYPE_NOD || player_type == PLAYERTYPE_GDI;
}

bool DamageableGameObj::Is_Enemy(DamageableGameObj *obj)
{
	bool enemy = false;
	if (obj != this)
	{
		int sTeamID1 = this->Get_Player_Type();
		int sTeamID2 = obj->Get_Player_Type();
		if ( sTeamID1 != -2 && sTeamID2 != -2 && sTeamID1 != -4 && sTeamID2 != -4 )
		{
			if ( sTeamID1 != -1 && sTeamID2 != -1 )
			{
				enemy = sTeamID1 != sTeamID2;
			}
			else
			{
				enemy = true;
			}
		}
		else
		{
			enemy = false;
		}
	}
	return enemy;
}

AnimControlClass *PhysicalGameObj::Get_Anim_Control()
{
	return AnimControl;
}

void PhysicalGameObj::Get_Position(Vector3 *Position) const
{
	*Position = Peek_Physical_Object()->Get_Transform().Get_Translation();
}

const PowerUpGameObjDef & PowerUpGameObj::Get_Definition( void ) const
{
	return (const PowerUpGameObjDef &)BaseGameObj::Get_Definition();
}

const PhysicalGameObjDef & PhysicalGameObj::Get_Definition( void ) const
{
	return (const PhysicalGameObjDef &)BaseGameObj::Get_Definition();
}

SCRIPTS_API bool Verify_Preset_Limit(int team, int instance_count, uint32* preset_ids, int preset_id_count, GameObject* ignore)
{
	for (SLNode<SmartGameObj>* node = GameObjManager::SmartGameObjList.Head(); node; node = node->Next())
	{
		SmartGameObj* object = node->Data();
		if (object != ignore && (object->Get_Player_Type() == team || team == 2))
		{
			for (int i = 0; i < preset_id_count; ++i)
			{
				if ((uint32)object->Get_Definition().Get_ID() == preset_ids[i] && --instance_count == 0) return true;
			}
		}
	}
	return false;
}
#endif