/*	Renegade Scripts.dll
	Copyright 2011 Tiberian Technologies

	This file is part of the Renegade scripts.dll
	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
	the terms of the GNU General Public License as published by the Free
	Software Foundation; either version 2, or (at your option) any later
	version. See the file COPYING for more details.
	In addition, an exemption is given to allow Run Time Dynamic Linking of this code with any closed source module that does not contain code covered by this licence.
	Only the source code to the module(s) containing the licenced code has to be released.
*/
#ifndef SCRIPTS_INCLUDE__ENGINE_TDB_H
#define SCRIPTS_INCLUDE__ENGINE_TDB_H
#include "scripts.h"

SCRIPTS_API const char *Get_Translated_String(unsigned long ID); //Get a string from the translation database given its ID
SCRIPTS_API const char *Get_Translated_Preset_Name(GameObject *obj); //Get the translated name for the preset of this object, if it has one
SCRIPTS_API const char *Get_Translated_Weapon(GameObject *obj,int position); //Get the translated name of a weapon
SCRIPTS_API const char *Get_Current_Translated_Weapon(GameObject *obj); //Get the translated name of the current weapon
SCRIPTS_API const char *Get_Team_Name(int Team); //Get a teams name
SCRIPTS_API const char *Get_Vehicle_Name(GameObject *obj); //Get the name of a vehicle (as used for the HUD display)
SCRIPTS_API const char *Get_Translated_Definition_Name(const char *preset); //Get the translated name string for a preset name
SCRIPTS_API const wchar_t *Get_Wide_Translated_String(unsigned long ID); //Get a wide string from the translation database given its ID
SCRIPTS_API const wchar_t *Get_Wide_Vehicle_Name(GameObject *obj); //Get the name of a vehicle (as used for the HUD display) as a wide character string
SCRIPTS_API const wchar_t *Get_Current_Wide_Translated_Weapon(GameObject *obj); //Get the translated name of the current weapon as a wide character string

SCRIPTS_API bool Is_Valid_String_ID(unsigned long ID); //Like Is_Valid_Preset_ID but for strings, returns true if the string ID exists
SCRIPTS_API unsigned long Get_String_ID_By_Desc(const char *desc); //Get the ID of a string given it's ID_Desc
SCRIPTS_API unsigned long Get_String_Sound_ID(unsigned long ID); //Get the ID of the sound preset for this string
#endif
