/*	Renegade Scripts.dll
	Scripts by zunnie - http://dev.mp-gaming.com
	Copyright 2011-2012 MP-Gaming

	This file is part of the Renegade scripts.dll
	The Renegade scripts.dll is free software; you can redistribute it and/or modify it 
	under the terms of the GNU General Public License as published by the Free
	Software Foundation; either version 2, or (at your option) any later
	version. See the file COPYING for more details.
	In addition, an exemption is given to allow Run Time Dynamic Linking of this code 
	with any closed source module that does not contain code covered by this licence.
	Only the source code to the module(s) containing the licenced code has to be released.
*/
#include "General.h"
#include "scripts.h"
#include "engine.h"
#include "BuildingGameObj.h"
#include "tcw_center_point.h"
#include "GameObjManager.h"
#include "SoldierGameObj.h"
#include "VehicleGameObj.h"

void tcw_cp_cruiser_countdown_point::Created(GameObject *obj)
{
	nod_bar_turret_id = 100065; nod_ref_turret_id = 100067; gdi_hand_turret_id = 100068; gdi_ref_turret_id = 100070;	
	nodveh1id = 0; nodveh2id = 0; gdiveh1id = 0; gdiveh2id = 0;
	Commands->Set_Player_Type(obj,-2);
	Commands->Set_Health(obj,2.0f);
	create_cruiser_countdown_object = true;
}
void tcw_cp_cruiser_countdown_point::Damaged(GameObject *obj, GameObject *damager, float damage)
{
	if (Commands->Is_A_Star(damager))//is it a player?
	{
		if (damage < 0.0f)//if damage is less than 0 it must being repaired...
		{
			if (Commands->Get_Player_Type(obj) == -2)//unteamed
			{
				Commands->Set_Player_Type(obj,Commands->Get_Player_Type(damager));//if someone is repairing it then set it to their team
			}
			if (Commands->Get_Player_Type(obj) == 0) //if it is nods
			{
				if (Commands->Get_Health(obj) == Commands->Get_Max_Health(obj))//if fully repaired
				{
					if (create_cruiser_countdown_object)//if the cruisercountdown object may be created
					{
						Send_Message(255,255,255,"Nod has captured the Countdown Point. 1 Minute for Cruiser Attacks.");
						create_cruiser_countdown_object = false;//its being created here so we set it to false so it doesnt get made a 2nd time
						Vector3 countdown_object_pos;
						countdown_object_pos.X = 0.0f; countdown_object_pos.Y = 0.0f; countdown_object_pos.Z = 0.0f;
						GameObject *countdown_object = Commands->Create_Object("Invisible_Object",countdown_object_pos);

						char prms[250];
						sprintf(prms,"%d,%d,%d,%d,%d",0,nod_bar_turret_id,nod_ref_turret_id,gdi_hand_turret_id,gdi_ref_turret_id);
						Attach_Script_Once(countdown_object,"tcw_cp_cruiser_countdown",prms);

						if (!Commands->Find_Object(nodveh1id))
						{
							if (strcmp(Get_Parameter("NodVeh1"), "0") != 0)
							{
								Vector3 nodveh1pos = Get_Vector3_Parameter("NodVeh1Pos");
								float nodveh1fac = Get_Float_Parameter("NodVeh1Facing");
								GameObject *nodveh1 = Commands->Create_Object(Get_Parameter("NodVeh1"),nodveh1pos);
								Commands->Set_Facing(nodveh1,nodveh1fac);
								nodveh1id = Commands->Get_ID(nodveh1);
								Attach_Script_Once(nodveh1,"tcw_domination_vehicle","0");
							}
						}
						if (!Commands->Find_Object(nodveh2id))
						{
							if (strcmp(Get_Parameter("NodVeh2"), "0") != 0)
							{
								Vector3 nodveh2pos = Get_Vector3_Parameter("NodVeh2Pos");
								float nodveh2fac = Get_Float_Parameter("NodVeh2Facing");
								GameObject *nodveh2 = Commands->Create_Object(Get_Parameter("NodVeh2"),nodveh2pos);
								Commands->Set_Facing(nodveh2,nodveh2fac);
								nodveh2id = Commands->Get_ID(nodveh2);
								Attach_Script_Once(nodveh2,"tcw_domination_vehicle","0");
							}
						}
					}
				}
			}
			else if (Commands->Get_Player_Type(obj) == 1)//if its gdi's
			{
				if (Commands->Get_Health(obj) == Commands->Get_Max_Health(obj))//if fully repaired
				{
					if (create_cruiser_countdown_object)
					{
						Send_Message(255,255,255,"GDI has captured the Countdown Point. 1 Minute for Cruiser Attacks.");
						create_cruiser_countdown_object = false;
						Vector3 countdown_object_pos;
						countdown_object_pos.X = 0.0f; countdown_object_pos.Y = 0.0f; countdown_object_pos.Z = 0.0f;
						GameObject *countdown_object = Commands->Create_Object("Invisible_Object",countdown_object_pos);
						
						char prms[250];
						sprintf(prms,"%d,%d,%d,%d,%d",1,nod_bar_turret_id,nod_ref_turret_id,gdi_hand_turret_id,gdi_ref_turret_id);
						Attach_Script_Once(countdown_object,"tcw_cp_cruiser_countdown",prms);

						if (!Commands->Find_Object(nodveh1id))
						{
							if (strcmp(Get_Parameter("GDIVeh1"), "0") != 0)
							{
								Vector3 gdiveh1pos = Get_Vector3_Parameter("GDIVeh1Pos");
								float gdiveh1fac = Get_Float_Parameter("GDIVeh1Facing");
								GameObject *gdiveh1 = Commands->Create_Object(Get_Parameter("GDIVeh1"),gdiveh1pos);
								Commands->Set_Facing(gdiveh1,gdiveh1fac);
								gdiveh1id = Commands->Get_ID(gdiveh1);
								Attach_Script_Once(gdiveh1,"tcw_domination_vehicle","1");
							}
						}
						if (!Commands->Find_Object(nodveh2id))
						{
							if (strcmp(Get_Parameter("GDIVeh2"), "0") != 0)
							{
								Vector3 gdiveh2pos = Get_Vector3_Parameter("GDIVeh2Pos");
								float gdiveh2fac = Get_Float_Parameter("GDIVeh2Facing");
								GameObject *gdiveh2 = Commands->Create_Object(Get_Parameter("GDIVeh2"),gdiveh2pos);
								Commands->Set_Facing(gdiveh2,gdiveh2fac);
								gdiveh2id = Commands->Get_ID(gdiveh2);
								Attach_Script_Once(gdiveh2,"tcw_domination_vehicle","1");
							}
						}
					}
				}
			}
		}
		else if (damage > 0.0f)
		{
			if (Commands->Get_Player_Type(obj) == -2)
			{
				Commands->Set_Health(obj,2.0f);
			}
			else if (Commands->Get_Player_Type(damager) == 1)//if its gdi attacking it
			{
				if (damage >= Commands->Get_Health(obj))//point is destroyed
				{
					Send_Message(255,255,255,"Cruiser Attacks on GDI halted. Countdown Point destroyed.");
					Vector3 tur1pos = Commands->Get_Position(Commands->Find_Object(nod_bar_turret_id));//bar attacking turret for nod
					Vector3 tur2pos = Commands->Get_Position(Commands->Find_Object(nod_ref_turret_id));//ref attacking turret for nod
					float facingtur1 = Commands->Get_Facing(Commands->Find_Object(nod_bar_turret_id));
					float facingtur2 = Commands->Get_Facing(Commands->Find_Object(nod_ref_turret_id));
					Commands->Destroy_Object(Commands->Find_Object(nod_bar_turret_id));
					Commands->Destroy_Object(Commands->Find_Object(nod_ref_turret_id));
					GameObject *tur1 = Commands->Create_Object("TCW_Cruiser_Cannon_CDP",tur1pos);
					GameObject *tur2 = Commands->Create_Object("TCW_Cruiser_Cannon_CDP",tur2pos);
					Commands->Set_Facing(tur1,facingtur1); 
					Commands->Set_Player_Type(tur1,0);
					Commands->Set_Facing(tur2,facingtur2); 
					Commands->Set_Player_Type(tur2,0);
					nod_bar_turret_id = Commands->Get_ID(tur1);//this is the new bar attacking turret for nod
					nod_ref_turret_id = Commands->Get_ID(tur2);//this is the new ref attacking turret for nod
					Commands->Set_Player_Type(obj,1);//it now belongs to gdi because they fully destroyed it
					Commands->Set_Health(obj,2.0f);//we cant allow them to REALLY destroy it, otherwise the script halts and stuff....
					create_cruiser_countdown_object = true;

					//destroy the spawned vehicles
					if ( (Commands->Find_Object(nodveh1id)) && (!Get_Vehicle_Driver(Commands->Find_Object(nodveh1id))) )
					{
						Commands->Apply_Damage(Commands->Find_Object(nodveh1id),999999.0f,"Steel",obj);		nodveh1id = 0;
					}
					if ( (Commands->Find_Object(nodveh2id)) && (!Get_Vehicle_Driver(Commands->Find_Object(nodveh2id))) )
					{
						Commands->Apply_Damage(Commands->Find_Object(nodveh2id),999999.0f,"Steel",obj);		nodveh2id = 0;
					}
				}
			}
			else if (Commands->Get_Player_Type(damager) == 0)//if its nod attacking it
			{
				if (damage >= Commands->Get_Health(obj))//point is destroyed
				{
					Send_Message(255,255,255,"Cruiser Attacks on Nod halted. Countdown Point destroyed.");
					Vector3 tur1pos = Commands->Get_Position(Commands->Find_Object(gdi_hand_turret_id));//hon attacking turret for gdi
					Vector3 tur2pos = Commands->Get_Position(Commands->Find_Object(gdi_ref_turret_id));//ref attacking turret for gdi
					float facingtur1 = Commands->Get_Facing(Commands->Find_Object(gdi_hand_turret_id));
					float facingtur2 = Commands->Get_Facing(Commands->Find_Object(gdi_ref_turret_id));	
					Commands->Destroy_Object(Commands->Find_Object(gdi_hand_turret_id));
					Commands->Destroy_Object(Commands->Find_Object(gdi_ref_turret_id));
					GameObject *tur1 = Commands->Create_Object("TCW_Cruiser_Cannon_CDP",tur1pos);
					GameObject *tur2 = Commands->Create_Object("TCW_Cruiser_Cannon_CDP",tur2pos);
					Commands->Set_Facing(tur1,facingtur1); 
					Commands->Set_Player_Type(tur1,1);
					Commands->Set_Facing(tur2,facingtur2); 
					Commands->Set_Player_Type(tur2,1);
					gdi_hand_turret_id = Commands->Get_ID(tur1);//this is the new hand attacking turret for gdi
					gdi_ref_turret_id = Commands->Get_ID(tur2);//this is the new ref attacking turret for gdi
					Commands->Set_Player_Type(obj,0);//it now belongs to nod because they fully destroyed it
					Commands->Set_Health(obj,2.0f);//we cant allow them to REALLY destroy it, otherwise the script halts and stuff....
					create_cruiser_countdown_object = true;

					//destroy the spawned vehicles
					if ( (Commands->Find_Object(gdiveh1id)) && (!Get_Vehicle_Driver(Commands->Find_Object(gdiveh1id))) )
					{
						Commands->Apply_Damage(Commands->Find_Object(gdiveh1id),999999.0f,"Steel",obj);		gdiveh1id = 0;
					}
					if ( (Commands->Find_Object(gdiveh2id)) && (!Get_Vehicle_Driver(Commands->Find_Object(gdiveh2id))) )
					{
						Commands->Apply_Damage(Commands->Find_Object(gdiveh2id),999999.0f,"Steel",obj);		gdiveh2id = 0;
					}
				}
			}
		}
	}
}
void tcw_cp_cruiser_countdown_point::Register_Auto_Save_Variables()
{
	Auto_Save_Variable(&create_cruiser_countdown_object,sizeof(create_cruiser_countdown_object),1);
	Auto_Save_Variable(&nodveh1id,sizeof(nodveh1id),2);
	Auto_Save_Variable(&nodveh2id,sizeof(nodveh2id),3);
	Auto_Save_Variable(&gdiveh1id,sizeof(gdiveh1id),4);
	Auto_Save_Variable(&gdiveh2id,sizeof(gdiveh2id),5);
}

void tcw_cp_cruiser_countdown::Created(GameObject *obj)
{
	team = Get_Int_Parameter("Team");
	turretbarnod = Get_Int_Parameter("NodTurretBar_ID");
	turretrefnod = Get_Int_Parameter("NodTurretRef_ID");
	turrethongdi = Get_Int_Parameter("GDITurretHon_ID");
	turretrefgdi = Get_Int_Parameter("GDITurretRef_ID");
	if (team == 0)
	{
		Commands->Start_Timer(obj,this,60.0f,100);
	}
	else if (team == 1)
	{
		Commands->Start_Timer(obj,this,60.0f,101);
	}
}
void tcw_cp_cruiser_countdown::Timer_Expired(GameObject *obj, int number)
{
	if (number == 100) // nod timer hits so we need the turrets from nod which attack gdi base:
	{
		//100065 -> bar			100067 -> ref (turrets)
		//100062 -> barattack	100071 -> refattack (attackpoints)
		Attach_Script_Once(Commands->Find_Object(turretbarnod),"tcw_cp_cruiser_attack","100062");//turret 1 that attacks the barracks
		Attach_Script_Once(Commands->Find_Object(turretrefnod),"tcw_cp_cruiser_attack","100071");//turret 2 that attacks the refinery
	}
	else if (number == 101)
	{
		//100068 -> hand			100070 -> ref (turrets)
		//100073 -> handattack		100072 -> refattack (attackpoints)
		Attach_Script_Once(Commands->Find_Object(turrethongdi),"tcw_cp_cruiser_attack","100073");//turret 1 that attacks the hand
		Attach_Script_Once(Commands->Find_Object(turretrefgdi),"tcw_cp_cruiser_attack","100072");//turret 2 that attacks the refinery
	}
}
void tcw_cp_cruiser_countdown::Register_Auto_Save_Variables()
{
	Auto_Save_Variable(&team,sizeof(team),1);
	Auto_Save_Variable(&turretbarnod,sizeof(turretbarnod),2);
	Auto_Save_Variable(&turretrefnod,sizeof(turretrefnod),3);
	Auto_Save_Variable(&turrethongdi,sizeof(turrethongdi),4);
	Auto_Save_Variable(&turretrefgdi,sizeof(turretrefgdi),5);
}

void tcw_cp_cruiser_attack::Created(GameObject *obj)//this script will immideately attack whatever is passed as the attack id
{
	Commands->Start_Timer(obj,this,1.0f,250);
	Commands->Create_2D_WAV_Sound("attackalert.wav");
}
void tcw_cp_cruiser_attack::Timer_Expired(GameObject *obj, int number)
{
	if (number == 250)
	{
		ActionParamsStruct params;
		int priority = 100;		float range = 1000.0f;		float deviation = 0.0f;		int primary = 1;
		params.Set_Basic(this,(float)priority,40016);
		params.Set_Attack(Commands->Find_Object(Get_Int_Parameter("Attack_ID")),range,deviation,primary);
		params.AttackCheckBlocked = false;
		Commands->Action_Attack(obj,params);
		Commands->Start_Timer(obj,this,1.0f,250);
	}
}
void tcw_cp_cruiser_attack::Action_Complete(GameObject *obj,int action,ActionCompleteReason reason)
{
	Commands->Action_Reset(obj,100);
}

ScriptRegistrant<tcw_cp_cruiser_attack> tcw_cp_cruiser_attack_Registrant("tcw_cp_cruiser_attack","Attack_ID=1111:int,TurretID=0:int");
ScriptRegistrant<tcw_cp_cruiser_countdown> tcw_cp_cruiser_countdown_Registrant("tcw_cp_cruiser_countdown","Team=0:int,NodTurretBar_ID=1:int,NodTurretRef_ID=1:int,GDITurretHon_ID=1:int,GDITurretRef_ID=1:int");
ScriptRegistrant<tcw_cp_cruiser_countdown_point> tcw_cp_cruiser_countdown_point_Registrant("tcw_cp_cruiser_countdown_point","NodVeh1=asdf:string,NodVeh1Pos=0:vector3,NodVeh1Facing=0:float,NodVeh2=asdf:string,NodVeh2Pos=0:vector3,NodVeh2Facing=0:float,GDIVeh1=asdf:string,GDIVeh1Pos=0:vector3,GDIVeh1Facing=0:float,GDIVeh2=asdf:string,GDIVeh2Pos=0:vector3,GDIVeh2Facing=0:float");