/*	Renegade Scripts.dll
	Scripts by zunnie - http://dev.mp-gaming.com
	Copyright 2011-2012 MP-Gaming

	This file is part of the Renegade scripts.dll
	The Renegade scripts.dll is free software; you can redistribute it and/or modify it 
	under the terms of the GNU General Public License as published by the Free
	Software Foundation; either version 2, or (at your option) any later
	version. See the file COPYING for more details.
	In addition, an exemption is given to allow Run Time Dynamic Linking of this code 
	with any closed source module that does not contain code covered by this licence.
	Only the source code to the module(s) containing the licenced code has to be released.
*/
#include "General.h"
#include "scripts.h"
#include "engine.h"
#include "BuildingGameObj.h"
#include "tcw_game.h"
#include "GameObjManager.h"
#include "SoldierGameObj.h"
#include "VehicleGameObj.h"

void tcw_Tiberium_Harvester::Created(GameObject *obj)
{
	team = 0;
	driver = 0;
	cash = 0;
	ID = 0;
	if ( (strcmp(Commands->Get_Preset_Name(obj),"TCW_Nod_Harvester") == 0) || (strcmp(Commands->Get_Preset_Name(obj),"TCW_Nod_Harvester_Player") == 0) || (strcmp(Commands->Get_Preset_Name(obj),"TCW_GDI_Nod_Harvester_Player") == 0) ) 
	{
		VehicleGameObj* harvester = obj->As_VehicleGameObj();
		if (!harvester) return;
		harvester->Set_Allow_Stealth_While_Empty(true);
	}
}
void tcw_Tiberium_Harvester::Custom(GameObject *obj,int type,int param,GameObject *sender)
{
	int Collected_Message = Get_Int_Parameter("Collected_Message");
	int Refinery_Message = Get_Int_Parameter("Refinery_Message");
	int Cash_Limit = Get_Int_Parameter("Cash_Limit");
	int Cash_Type = Get_Int_Parameter("Cash_Type");
	int Entire_Team = Get_Int_Parameter("Entire_Team");
	if (type == CUSTOM_EVENT_VEHICLE_ENTERED)
	{
		team = Commands->Get_Player_Type(sender);
		driver = Commands->Get_ID(sender);
		int OldID;
		OldID = ID;
		ID = Commands->Get_ID(sender);
		if (!Cash_Type)
		{
			cash = 0;
		}
		if ((Cash_Type == 1) && (ID != OldID))
		{
			cash = 0;
		}
		if (team == 0)
		{
			Send_Message_Player(Commands->Find_Object(driver),255,0,0,"Drive to the Tiberium Field to harvest Tiberium.");
			Create_2D_WAV_Sound_Player(Commands->Find_Object(driver),"incmsg.wav");
		}
		else if (team == 1)
		{
			Send_Message_Player(Commands->Find_Object(driver),255,204,0,"Drive to the Tiberium Field to harvest Tiberium.");
			Create_2D_WAV_Sound_Player(Commands->Find_Object(driver),"incmsg.wav");
		}
	}
	if (type == CUSTOM_EVENT_VEHICLE_EXITED)
	{
		driver = 0;
	}
	if (type == Collected_Message)
	{
		if (Cash_Type == 3)
		{
			cash = 0;
		}
		cash += param;
		if ((cash > Cash_Limit) && (Cash_Limit))
		{
			cash = Cash_Limit;
		}
		if (team == 0)
		{
			Send_Message_Player(Commands->Find_Object(driver),255,0,0,"Tiberium harvesting has completed, return to the Refinery.");
			Create_2D_WAV_Sound_Player(Commands->Find_Object(driver),"incmsg.wav");
		}
		else if (team == 1)
		{
			Send_Message_Player(Commands->Find_Object(driver),255,204,0,"Tiberium harvesting has completed, return to the Refinery.");
			Create_2D_WAV_Sound_Player(Commands->Find_Object(driver),"incmsg.wav");
		}
	}
	if (type == Refinery_Message)
	{
		if (cash > 0)
		{
			int team = Commands->Get_Player_Type(obj);
			if (!Is_Building_Dead(Find_Building(team,BuildingConstants::TYPE_REFINERY)))
			{
				Commands->Give_Money(Commands->Find_Object(ID),(float)cash,Entire_Team);
				Commands->Give_Points(Commands->Find_Object(ID),50.0f,0);//50 points for the effort ;)
				if (team == 0)
				{
					char dumpmsg[250];
					sprintf(dumpmsg,"%s deposited Tiberium funding Nod with %g additional credits.",Get_Player_Name(Commands->Find_Object(driver)),cash);
					Send_Message_Team(0,255,0,0,dumpmsg);
					Create_2D_WAV_Sound_Team("creditsacquired.wav",0);
				}
				else if (team == 1)
				{
					char dumpmsg[250];
					sprintf(dumpmsg,"%s deposited Tiberium funding GDI with %g additional credits.",Get_Player_Name(Commands->Find_Object(driver)),cash);
					Send_Message_Team(1,255,204,0,dumpmsg);
					Create_2D_WAV_Sound_Team("creditsacquired.wav",1);
				}
			}
		}

		cash = 0;
	}
}
void tcw_Tiberium_Harvester::Register_Auto_Save_Variables()
{
	Auto_Save_Variable(&cash,sizeof(cash),1);
	Auto_Save_Variable(&ID,sizeof(ID),2);
	Auto_Save_Variable(&driver,sizeof(driver),3);
	Auto_Save_Variable(&team,sizeof(team),4);
}


void tcw_tiberium_spike::Created(GameObject *obj)
{
	firstcapture = true;
	Commands->Set_Animation(obj,"V_NEU_SPIKE.V_NEU_SPIKE",true,0,1,-1,0);
}
void tcw_tiberium_spike::Custom(GameObject *obj, int message, int param, GameObject *sender)
{
	if (message == 1000)
	{
		if (param == 0)
		{
			Commands->Set_Player_Type(obj,0);
			if (firstcapture)
			{
				firstcapture = false;
				Commands->Give_Money(obj,250.0f,1);
				Attach_Script_Once(obj,"tcw_Credit_Trickle","5,1");
			}
			else
			{
				Attach_Script_Once(obj,"tcw_Credit_Trickle","5,1");
			}
		}
		else if (param == 1)
		{
			Commands->Set_Player_Type(obj,1);
			if (firstcapture)
			{
				firstcapture = false;
				Commands->Give_Money(obj,250.0f,1);
				Attach_Script_Once(obj,"tcw_Credit_Trickle","5,1");
			}
			else
			{
				Attach_Script_Once(obj,"tcw_Credit_Trickle","5,1");
			}
		}
	}
	else if (message == 1001)//needed for settings the spike team without granting the 'firstcapture' money
	{
		if (param == 0)
		{
			Commands->Set_Player_Type(obj,0);
			if (firstcapture)
			{
				firstcapture = false;
				Attach_Script_Once(obj,"tcw_Credit_Trickle","5,1");
			}
			else
			{
				Attach_Script_Once(obj,"tcw_Credit_Trickle","5,1");
			}
		}
		else if (param == 1)
		{
			Commands->Set_Player_Type(obj,1);
			if (firstcapture)
			{
				firstcapture = false;
				Attach_Script_Once(obj,"tcw_Credit_Trickle","5,1");
			}
			else
			{
				Attach_Script_Once(obj,"tcw_Credit_Trickle","5,1");
			}
		}
	}
}
void tcw_tiberium_spike::Register_Auto_Save_Variables()
{
	Auto_Save_Variable(&firstcapture,sizeof(firstcapture),1);
}

void tcw_tiberium_spike_capture::Created(GameObject *obj)
{
	capturer = 0;
	capturing = false;
}
void tcw_tiberium_spike_capture::Entered(GameObject *obj, GameObject *enter)
{
	if (Commands->Is_A_Star(enter))
	{
		if ( (Is_Script_Attached(enter,"tcw_i_can_capture_spike")) && (!Get_Vehicle(enter)) )
		{
			if (!Commands->Find_Object(capturer))
			{
				if (!capturing)
				{
					if ( (Commands->Get_Player_Type(Commands->Find_Object(Get_Int_Parameter("Spike_ID"))) == 0) && (Commands->Get_Player_Type(enter) == 0) )
					{
						Send_Message_Player(enter,255,0,0,"Your team already controls this Tiberium Spike.");
					}
					else if ( (Commands->Get_Player_Type(Commands->Find_Object(Get_Int_Parameter("Spike_ID"))) == 1) && (Commands->Get_Player_Type(enter) == 1) )
					{
						Send_Message_Player(enter,255,204,0,"Your team already controls this Tiberium Spike.");
					}
					else
					{
						capturer = Commands->Get_ID(enter);
						capturing = true;
						if (Commands->Get_Player_Type(Commands->Find_Object(capturer)) == 0)
						{
							Commands->Start_Timer(obj,this,20.0f,100);
						}
						else if (Commands->Get_Player_Type(Commands->Find_Object(capturer)) == 1)
						{
							Commands->Start_Timer(obj,this,20.0f,101);
						}
						if (Commands->Find_Object(capturer))
						{
							if (Commands->Get_Player_Type(Commands->Find_Object(capturer)) == 0)
							{
								char capturerd[250];
								sprintf(capturerd,"%s is capturing a Tiberium Spike.",Get_Player_Name(Commands->Find_Object(capturer)));
								Send_Message_Team(0,255,0,0,capturerd);
								Create_2D_WAV_Sound_Team("building_capture.wav",0);
							}
							else if (Commands->Get_Player_Type(Commands->Find_Object(capturer)) == 1)
							{
								char capturerd[250];
								sprintf(capturerd,"%s is capturing a Tiberium Spike.",Get_Player_Name(Commands->Find_Object(capturer)));
								Send_Message_Team(1,255,204,0,capturerd);
								Create_2D_WAV_Sound_Team("building_capture.wav",1);
							}
						}
					}
				}
				else
				{
					Send_Message_Player(enter,255,255,255,"Capturing in progress, please try again in 30 seconds.");
				}
			}
		}
	}
}
void tcw_tiberium_spike_capture::Exited(GameObject *obj, GameObject *exit)
{
	if (Commands->Is_A_Star(exit))
	{
		if (Commands->Get_ID(exit) == capturer)
		{
			capturer = 0;
			capturing = false;
		}
	}
}
void tcw_tiberium_spike_capture::Timer_Expired(GameObject *obj, int number)
{
	if (number == 100)
	{
		if (capturing)
		{
			if (Commands->Find_Object(capturer))
			{
				int oldspiketeam = Commands->Get_Player_Type(Commands->Find_Object(Get_Int_Parameter("Spike_ID")));	
				Commands->Send_Custom_Event(obj,Commands->Find_Object(Get_Int_Parameter("Spike_ID")),1000,0,0);
				char good[250];
				sprintf(good,"%s captured a Tiberium Spike.",Get_Player_Name(Commands->Find_Object(capturer)));
				Send_Message(255,255,255,good);

				if (oldspiketeam == 1)
				{
					Create_2D_WAV_Sound_Team("nod_building_captured.wav",0);
					Send_Message_Team(0,255,0,0,"Building captured.");
					Create_2D_WAV_Sound_Team("gdi_building_captured_our.wav",1);
					Send_Message_Team(1,255,204,0,"Our building has been captured.");
				}
				else
				{
					Create_2D_WAV_Sound_Team("nod_building_captured.wav",0);
					Send_Message_Team(0,255,0,0,"Building captured.");
				}
				Commands->Give_Points(Commands->Find_Object(capturer),250.0f,0);
				Remove_Script(Commands->Find_Object(capturer),"tcw_i_can_capture_spike");
				capturing = false;
				capturer = 0;
			}
			else
			{
				capturing = false;
				capturer = 0;
			}
		}
		else 
		{
			capturing = false;
			capturer = 0;
		}
	}
	if (number == 101)
	{
		if (capturing)
		{
			if (Commands->Find_Object(capturer))
			{
				int oldspiketeam = Commands->Get_Player_Type(Commands->Find_Object(Get_Int_Parameter("Spike_ID")));	
				Commands->Send_Custom_Event(obj,Commands->Find_Object(Get_Int_Parameter("Spike_ID")),1000,1,0);
				char good[250];
				sprintf(good,"%s captured a Tiberium Spike.",Get_Player_Name(Commands->Find_Object(capturer)));
				Send_Message(255,255,255,good);

				if (oldspiketeam == 0)
				{
					Create_2D_WAV_Sound_Team("gdi_building_captured.wav",1);
					Send_Message_Team(1,255,204,0,"Building captured.");
					Create_2D_WAV_Sound_Team("nod_building_captured_our.wav",0);
					Send_Message_Team(0,255,0,0,"Our building has been captured.");
				}
				else
				{
					Create_2D_WAV_Sound_Team("gdi_building_captured.wav",1);
					Send_Message_Team(1,255,204,0,"Building captured.");
				}
				Commands->Give_Points(Commands->Find_Object(capturer),250.0f,0);
				Remove_Script(Commands->Find_Object(capturer),"tcw_i_can_capture_spike");
				capturing = false;
				capturer = 0;
			}
			else
			{
				capturing = false;
				capturer = 0;
			}
		}
		else 
		{
			capturing = false;
			capturer = 0;
		}
	}
}
void tcw_tiberium_spike_capture::Register_Auto_Save_Variables()
{
	Auto_Save_Variable(&capturer,sizeof(capturer),1);
	Auto_Save_Variable(&capturing,sizeof(capturing),2);
}

void tcw_i_can_capture_spike::Created(GameObject *obj)
{
	//checkscript for allowing capturing of spikes
}

void tcw_Credit_Trickle::Created(GameObject *obj)
{
	float delay;
	delay = Get_Float_Parameter("Delay");
	Commands->Start_Timer(obj,this,delay,667);
}

void tcw_Credit_Trickle::Timer_Expired(GameObject *obj,int number)
{
	if (number == 667)
	{
		Commands->Give_Money(obj,(float)Get_Int_Parameter("Credits"),true);
		float delay;
		delay = Get_Float_Parameter("Delay");
		Commands->Start_Timer(obj,this,delay,667);
	}
}

void tcw_Tiberium_Field::Created(GameObject *obj)
{
	ID = 0;
}

void tcw_Tiberium_Field::Entered(GameObject *obj,GameObject *enter)
{
	const char *Preset = Commands->Get_Preset_Name(enter);
	const char *Nod_PresetGreen = Get_Parameter("Nod_Preset_Green");
	const char *GDI_PresetGreen = Get_Parameter("GDI_Preset_Green");
	const char *Nod_PresetBlue = Get_Parameter("Nod_Preset_Blue");
	const char *GDI_PresetBlue = Get_Parameter("GDI_Preset_Blue");
	if (!ID)
	{
		if ( (!_stricmp(Preset,Nod_PresetGreen)) || (!_stricmp(Preset,GDI_PresetGreen)) || (!_stricmp(Preset,Nod_PresetBlue)) || (!_stricmp(Preset,GDI_PresetBlue)) )
		{
			ID = Commands->Get_ID(enter);
			Commands->Start_Timer(obj,this,Get_Float_Parameter("Time"),Get_Int_Parameter("TimerNum"));
			Commands->Send_Custom_Event(obj,enter,Get_Int_Parameter("StartHarvest"),0,0);
		}
	}
}

void tcw_Tiberium_Field::Exited(GameObject *obj,GameObject *exit)
{
	if (Commands->Get_ID(exit) == ID)
	{
		ID = 0;
		Commands->Send_Custom_Event(obj,exit,Get_Int_Parameter("StopHarvest"),0,0);
	}
}

void tcw_Tiberium_Field::Timer_Expired(GameObject *obj,int number)
{
	int Cash = Get_Int_Parameter("Cash");
	int Collected_Message = Get_Int_Parameter("Collected_Message");
	Vector3 pos;
	float angle;
	GameObject *object;
	const char *Collected_Preset = Get_Parameter("Collected_Preset");
	float Collected_Preset_Distance = Get_Float_Parameter("Collected_Preset_Distance");
	if (ID)
	{
		object = Commands->Find_Object(ID);
		Commands->Send_Custom_Event(obj,object,Collected_Message,Cash,0);
		pos = Commands->Get_Position(object);
		angle = Commands->Get_Facing(object);
		pos.X+=Collected_Preset_Distance*(float)cos(angle);
		pos.Y+=Collected_Preset_Distance*(float)sin(angle);
		Commands->Create_Object(Collected_Preset,pos);
		Commands->Send_Custom_Event(obj,object,Get_Int_Parameter("StopHarvest"),0,0);
	}
}

void tcw_Tiberium_Field::Register_Auto_Save_Variables()
{
	Auto_Save_Variable(&ID,sizeof(ID),1);
}

void tcw_Tiberium_Deposit::Entered(GameObject *obj,GameObject *enter)
{
	int Deposit_Message = Get_Int_Parameter("Deposit_Message");
	Commands->Send_Custom_Event(obj,enter,Deposit_Message,0,0);
}

void tcw_tiberium_spike_points::Created(GameObject *obj)
{
	firstcapture = true;
	Commands->Set_Animation(obj,"V_NEU_SPIKE.V_NEU_SPIKE",true,0,1,-1,0);
}
void tcw_tiberium_spike_points::Custom(GameObject *obj, int message, int param, GameObject *sender)
{
	if (message == 1000)
	{
		if (param == 0)
		{
			Commands->Set_Player_Type(obj,0);
			if (firstcapture)
			{
				firstcapture = false;
				Commands->Give_Money(obj,250.0f,true);
				Attach_Script_Once(obj,"tcw_Point_Trickle","5,1");
			}
			else
			{
				Attach_Script_Once(obj,"tcw_Point_Trickle","5,1");
			}
		}
		else if (param == 1)
		{
			Commands->Set_Player_Type(obj,1);
			if (firstcapture)
			{
				firstcapture = false;
				Commands->Give_Money(obj,250.0f,true);
				Attach_Script_Once(obj,"tcw_Point_Trickle","5,1");
			}
			else
			{
				Attach_Script_Once(obj,"tcw_Point_Trickle","5,1");
			}
		}
	}
}
void tcw_tiberium_spike_points::Register_Auto_Save_Variables()
{
	Auto_Save_Variable(&firstcapture,sizeof(firstcapture),1);
}

void tcw_Point_Trickle::Created(GameObject *obj)
{
	display = true;
	float delay;
	delay = Get_Float_Parameter("Delay");
	Commands->Start_Timer(obj,this,delay,667);
}

void tcw_Point_Trickle::Timer_Expired(GameObject *obj,int number)
{
	if (number == 667)
	{
		Commands->Give_Money(obj,(float)Get_Int_Parameter("Points"),true);
		if (Get_Team_Credits(Get_Object_Type(obj)) >= 50000)
		{
			if (display)
			{
				display = false;
				if (Get_Object_Type(obj) == 0)
				{
					Commands->Send_Custom_Event(obj,Find_Object_With_Script("tcw_Custom_Win_Game_Credits"),1000,0,1);
				}
				else if (Get_Object_Type(obj) == 1)
				{
					Commands->Send_Custom_Event(obj,Find_Object_With_Script("tcw_Custom_Win_Game_Credits"),1000,1,1);
				}
			}
		}
		float delay;
		delay = Get_Float_Parameter("Delay");
		Commands->Start_Timer(obj,this,delay,667);
	}
}
void tcw_Point_Trickle::Register_Auto_Save_Variables()
{
	Auto_Save_Variable(&display,sizeof(display),1);
}

void tcw_Custom_Win_Game_Credits::Custom(GameObject *obj, int message, int param, GameObject *sender)
{
	if (message == 1000)
	{
		if (param == 0)
		{
			float npoints = Get_Team_Credits(0);
			float gpoints = Get_Team_Credits(1);
			float nlead = npoints-gpoints;
			char pts[250];
			sprintf(pts,"amsg Nod wins with a %g credits lead",nlead);
			Console_Input(pts);
			Console_Input("win 0");
		}
		else if (param == 1)
		{
			float npoints = Get_Team_Credits(0);
			float gpoints = Get_Team_Credits(1);
			float glead = gpoints-npoints;
			char pts[250];
			sprintf(pts,"amsg GDI wins with a %g credits lead",glead);
			Console_Input(pts);
			Console_Input("win 1");
		}
		Destroy_Script();
	}
}

void tcw_Set_Spike_Team_Created::Created(GameObject *obj)
{
	int team = Get_Int_Parameter("Team");
	Commands->Send_Custom_Event(obj,obj,1001,team,1);
}

void tcw_Map_Intro::Created(GameObject *obj)
{
	Commands->Start_Timer(obj,this,10.0f,251);
	Commands->Start_Timer(obj,this,13.0f,252);
	Commands->Start_Timer(obj,this,16.0f,253);
	Commands->Start_Timer(obj,this,19.0f,254);
	Commands->Start_Timer(obj,this,22.0f,255);
}
void tcw_Map_Intro::Timer_Expired(GameObject *obj, int number)
{
	if (number == 251)
	{
		if (_stricmp(Get_Parameter("Intro1"), "0") != 0)
		{
			char intro1[250];
			sprintf(intro1,"%s",Get_Parameter("Intro1"));
			Send_Message(Get_Int_Parameter("Red"),Get_Int_Parameter("Green"),Get_Int_Parameter("Blue"),intro1);
		}
	}
	else if (number == 252)
	{
		if (_stricmp(Get_Parameter("Intro2"), "0") != 0)
		{
			char intro2[250];
			sprintf(intro2,"%s",Get_Parameter("Intro2"));
			Send_Message(Get_Int_Parameter("Red"),Get_Int_Parameter("Green"),Get_Int_Parameter("Blue"),intro2);
		}
	}
	else if (number == 253)
	{
		if (_stricmp(Get_Parameter("Intro3"), "0") != 0)
		{
			char intro3[250];
			sprintf(intro3,"%s",Get_Parameter("Intro3"));
			Send_Message(Get_Int_Parameter("Red"),Get_Int_Parameter("Green"),Get_Int_Parameter("Blue"),intro3);
		}
	}
	else if (number == 254)
	{
		if (_stricmp(Get_Parameter("Intro4"), "0") != 0)
		{
			char intro4[250];
			sprintf(intro4,"%s",Get_Parameter("Intro4"));
			Send_Message(Get_Int_Parameter("Red"),Get_Int_Parameter("Green"),Get_Int_Parameter("Blue"),intro4);
		}
	}
	else if (number == 255)
	{
		if (_stricmp(Get_Parameter("Intro5"), "0") != 0)
		{
			char intro5[250];
			sprintf(intro5,"%s",Get_Parameter("Intro5"));
			Send_Message(Get_Int_Parameter("Red"),Get_Int_Parameter("Green"),Get_Int_Parameter("Blue"),intro5);
		}
	}
}

void tcw_Tiberium_Field_New::Created(GameObject *obj)
{
	zonetype = Get_Int_Parameter("Zonetype");//0=green 1=blue
}
void tcw_Tiberium_Field_New::Entered(GameObject *obj, GameObject *enter)
{
	if ( (strcmp(Commands->Get_Preset_Name(enter),"TCW_GDI_Harvester_Player") == 0) || 
		 (strcmp(Commands->Get_Preset_Name(enter),"TCW_Nod_GDI_Harvester_Player") == 0) || 
		 (strcmp(Commands->Get_Preset_Name(enter),"TCW_GDI_Nod_Harvester_Player") == 0) || 
		 (strcmp(Commands->Get_Preset_Name(enter),"TCW_Nod_Harvester_Player") == 0) )
	{
		if (zonetype == 0)//green
		{
			Commands->Send_Custom_Event(obj,enter,10500,0,0);//tell harv a green zone entered
		}
		else if (zonetype == 1)//blue
		{
			Commands->Send_Custom_Event(obj,enter,10500,1,0);//tell harv a blue zone entered
		}
	}
}
void tcw_Tiberium_Field_New::Exited(GameObject *obj, GameObject *exit)
{
	if ( (strcmp(Commands->Get_Preset_Name(exit),"TCW_GDI_Harvester_Player") == 0) || 
		 (strcmp(Commands->Get_Preset_Name(exit),"TCW_Nod_GDI_Harvester_Player") == 0) || 
		 (strcmp(Commands->Get_Preset_Name(exit),"TCW_GDI_Nod_Harvester_Player") == 0) || 
		 (strcmp(Commands->Get_Preset_Name(exit),"TCW_Nod_Harvester_Player") == 0) )
	{
		Commands->Send_Custom_Event(obj,exit,10500,3,0);//tell harv left zone
	}
}
void tcw_Tiberium_Field_New::Register_Auto_Save_Variables()
{
	Auto_Save_Variable(&zonetype,sizeof(zonetype),1);
}

void tcw_Tiberium_Harvester_New::Created(GameObject *obj)
{
	harvesting = false;
	tiberiumvalue = 0.0f;
	hasgreen = false;
	hasblue = false;
	team = -1;
	driverid = 0;
	if ( (strcmp(Commands->Get_Preset_Name(obj),"TCW_Nod_Harvester") == 0) || (strcmp(Commands->Get_Preset_Name(obj),"TCW_GDI_Nod_Harvester_Player") == 0) || (strcmp(Commands->Get_Preset_Name(obj),"TCW_Nod_Harvester_Player") == 0) )
	{
		VehicleGameObj* harvester = obj->As_VehicleGameObj();
		if (!harvester) return;
		harvester->Set_Allow_Stealth_While_Empty(true);
	}
}
void tcw_Tiberium_Harvester_New::Custom(GameObject *obj, int message, int param, GameObject *sender)
{
	if (message == CUSTOM_EVENT_VEHICLE_ENTERED)
	{
		team = Commands->Get_Player_Type(sender);
		driverid = Commands->Get_ID(sender);
		if (team == 0)
		{
			Send_Message_Player(Commands->Find_Object(driverid),255,0,0,"Drive to a Tiberium Field to harvest Tiberium.");
			Create_2D_WAV_Sound_Player(Commands->Find_Object(driverid),"incmsg.wav");
		}
		else if (team == 1)
		{
			Send_Message_Player(Commands->Find_Object(driverid),255,204,0,"Drive to a Tiberium Field to harvest Tiberium.");
			Create_2D_WAV_Sound_Player(Commands->Find_Object(driverid),"incmsg.wav");
		}
	}
	else if (message == CUSTOM_EVENT_VEHICLE_EXITED)
	{
		harvesting = false;
		driverid = 0;
		team = -1;
	}
	else if (message == 10500)
	{
		if (param == 0)//green tib entered
		{
			if (Commands->Find_Object(driverid))
			{
				if (!hasblue)
				{
					hasgreen = true;
					harvesting = true;
					Commands->Start_Timer(obj,this,1.0f,10500);
				}
			}
		}
		else if (param == 1)//blue tib entered
		{
			if (Commands->Find_Object(driverid))
			{
				if (!hasgreen)
				{
					hasblue = true;
					harvesting = true;
					Commands->Start_Timer(obj,this,1.0f,10501);
				}
			}
		}
		else if (param == 3)//harv left the zone
		{
			harvesting = false;
		}
		else if (param == 4)//deposit
		{
			if (tiberiumvalue > 0.0f)
			{
				if (Commands->Find_Object(driverid))
				{
					if (!Is_Building_Dead(Find_Building(team,BuildingConstants::TYPE_REFINERY)))
					{
						Commands->Give_Money(Commands->Find_Object(driverid),tiberiumvalue,true);
						Commands->Give_Points(Commands->Find_Object(driverid),50.0f,0);
						if (team == 0)
						{
							char dumpmsg[250];
							sprintf(dumpmsg,"%s deposited Tiberium funding Nod with %g additional credits.",Get_Player_Name(Commands->Find_Object(driverid)),tiberiumvalue);
							Send_Message_Team(0,255,0,0,dumpmsg);
							Create_2D_WAV_Sound_Team("creditsacquired_nod.wav",0);
						}
						else if (team == 1)
						{
							char dumpmsg[250];
							sprintf(dumpmsg,"%s deposited Tiberium funding GDI with %g additional credits.",Get_Player_Name(Commands->Find_Object(driverid)),tiberiumvalue);
							Send_Message_Team(1,255,204,0,dumpmsg);
							Create_2D_WAV_Sound_Team("creditsacquired_gdi.wav",1);
						}
						tiberiumvalue = 0.0f;
						hasblue = false;
						hasgreen = false;
					}
				}
			}
		}
	}
}
void tcw_Tiberium_Harvester_New::Timer_Expired(GameObject *obj, int number)
{
	if (number == 10500)//green
	{
		if (harvesting)
		{
			if (tiberiumvalue < 1400.0f)
			{
				Commands->Start_Timer(obj,this,1.0f,10500);
				tiberiumvalue = tiberiumvalue+100.0f;

				if (team == 0)
				{
					char amount[250];
					sprintf(amount,"You harvested $%g worth of Tiberium Crystals.",tiberiumvalue);
					Send_Message_Player(Commands->Find_Object(driverid),255,0,0,amount);
				}
				else if (team == 1)
				{
					char amount[250];
					sprintf(amount,"You harvested $%g worth of Tiberium Crystals.",tiberiumvalue);
					Send_Message_Player(Commands->Find_Object(driverid),255,204,0,amount);
				}

				if (tiberiumvalue == 1400.0f)
				{
					if (team == 0)
					{
						Send_Message_Player(Commands->Find_Object(driverid),255,0,0,"Tiberium harvesting has completed, return to the Refinery.");
						Create_2D_WAV_Sound_Player(Commands->Find_Object(driverid),"incmsg.wav");
					}
					else if (team == 1)
					{
						Send_Message_Player(Commands->Find_Object(driverid),255,204,0,"Tiberium harvesting has completed, return to the Refinery.");
						Create_2D_WAV_Sound_Player(Commands->Find_Object(driverid),"incmsg.wav");
					}
					harvesting = false;
				}
			}
		}
	}
	else if (number == 10501)//blue
	{
		if (harvesting)
		{
			if (tiberiumvalue < 2800.0f)
			{
				Commands->Start_Timer(obj,this,1.0f,10501);
				tiberiumvalue = tiberiumvalue+200.0f;

				if (team == 0)
				{
					char amount[250];
					sprintf(amount,"You harvested $%g worth of Tiberium Crystals.",tiberiumvalue);
					Send_Message_Player(Commands->Find_Object(driverid),255,0,0,amount);
				}
				else if (team == 1)
				{
					char amount[250];
					sprintf(amount,"You harvested $%g worth of Tiberium Crystals.",tiberiumvalue);
					Send_Message_Player(Commands->Find_Object(driverid),255,204,0,amount);
				}

				if (tiberiumvalue == 2800.0f)
				{
					if (team == 0)
					{
						Send_Message_Player(Commands->Find_Object(driverid),255,0,0,"Tiberium harvesting has completed, return to the Refinery.");
						Create_2D_WAV_Sound_Player(Commands->Find_Object(driverid),"incmsg.wav");
					}
					else if (team == 1)
					{
						Send_Message_Player(Commands->Find_Object(driverid),255,204,0,"Tiberium harvesting has completed, return to the Refinery.");
						Create_2D_WAV_Sound_Player(Commands->Find_Object(driverid),"incmsg.wav");
					}
				}
			}
		}
	}
}
void tcw_Tiberium_Harvester_New::Register_Auto_Save_Variables()
{
	Auto_Save_Variable(&harvesting,sizeof(harvesting),1);
	Auto_Save_Variable(&tiberiumvalue,sizeof(tiberiumvalue),2);
	Auto_Save_Variable(&hasgreen,sizeof(hasgreen),3);
	Auto_Save_Variable(&hasblue,sizeof(hasblue),4);
	Auto_Save_Variable(&team,sizeof(team),5);
	Auto_Save_Variable(&driverid,sizeof(driverid),6);
}

void tcw_Tiberium_Deposit_New::Entered(GameObject *obj, GameObject *enter)
{
	if ( (strcmp(Commands->Get_Preset_Name(enter),"TCW_GDI_Harvester_Player") == 0) || 
		 (strcmp(Commands->Get_Preset_Name(enter),"TCW_Nod_GDI_Harvester_Player") == 0) || 
		 (strcmp(Commands->Get_Preset_Name(enter),"TCW_GDI_Nod_Harvester_Player") == 0) ||
		 (strcmp(Commands->Get_Preset_Name(enter),"TCW_Nod_Harvester_Player") == 0) )
	{
		Commands->Send_Custom_Event(obj,enter,10500,4,0);//tell harv deposit tib
	}
}

void tcw_There_Must_Be_Engineer::Created(GameObject *obj)
{
	SList<SoldierGameObj> *player_list = &GameObjManager::StarGameObjList;
	SLNode<SoldierGameObj> *objnode;
	for (objnode = player_list->Head(); objnode; objnode = objnode->Next()) 
	{
		SoldierGameObj *soldier = objnode->Data();
		if ( soldier != NULL ) 
		{
			if (Commands->Get_Player_Type(soldier) == 0)
			{
				if (!Is_Building_Dead(Find_Building(0,BuildingConstants::TYPE_SOLDIER_FACTORY)))
				{
					if (strcmp(Commands->Get_Preset_Name(soldier),"CnC_Nod_Minigunner_0") == 0)
					{
						Change_Character(soldier,"TCW_Nod_Saboteur");
						break;
					}
					else if (strcmp(Commands->Get_Preset_Name(soldier),"TCW_Nod_Spawn_Low") == 0)
					{
						Change_Character(soldier,"TCW_Nod_Saboteur_Low");
						break;
					}
				}
				else
				{
					break;
				}
			}
			else if (Commands->Get_Player_Type(soldier) == 1)
			{
				if (!Is_Building_Dead(Find_Building(1,BuildingConstants::TYPE_SOLDIER_FACTORY)))
				{
					if (strcmp(Commands->Get_Preset_Name(soldier),"CnC_GDI_MiniGunner_0") == 0)
					{
						Change_Character(soldier,"TCW_GDI_Engineer");
						break;
					}
					else if (strcmp(Commands->Get_Preset_Name(soldier),"TCW_GDI_Spawn_Low") == 0)
					{
						Change_Character(soldier,"TCW_GDI_Engineer_Low");
						break;
					}
				}
				else
				{
					break;
				}
			}
		}
	}
}

void tcw_Enable_Refill::Created(GameObject *obj)
{
	//
}

void tcw_Buy_Beacon_Ion::Created(GameObject *obj)
{
	type = Get_Int_Parameter("Type");//1=10s 2=60s beacon
	allowpoke = true; Commands->Enable_HUD_Pokable_Indicator(obj, true);
	ionholder = 0;
	ready = false;
	charging = true; Commands->Start_Timer(obj,this,30.0f,100100);//commence charging of the ion
}
void tcw_Buy_Beacon_Ion::Register_Auto_Save_Variables()
{
	Auto_Save_Variable(&type,sizeof(type),1);
	Auto_Save_Variable(&allowpoke,sizeof(allowpoke),2);
	Auto_Save_Variable(&ionholder,sizeof(ionholder),3);
	Auto_Save_Variable(&ready,sizeof(ready),4);
	Auto_Save_Variable(&charging,sizeof(charging),5);
}
void tcw_Buy_Beacon_Ion::Timer_Expired(GameObject *obj, int number)
{
	if (number == 100100)
	{
		if (!Is_Building_Dead(Find_Object_By_Preset(1,"GDI_Ion_Control_Center")))
		{
			if (charging)
			{
				ready = true;
				charging = false;
				Create_2D_WAV_Sound_Team("gdi_ion_cannon_ready.wav",1);
				Send_Message_Team(1,255,204,0,"Ion Cannon Ready.");
			}
		}
	}
	else if (number == 100101)
	{
		if (!Is_Building_Dead(Find_Object_By_Preset(1,"GDI_Ion_Control_Center")))
		{
			allowpoke = true; Commands->Enable_HUD_Pokable_Indicator(obj, true);
		}
	}
}
void tcw_Buy_Beacon_Ion::Poked(GameObject *obj, GameObject *poker)
{
	if (allowpoke)
	{
		if (Commands->Get_Player_Type(poker) == 1)
		{
			if (ready)
			{
				if (!ionholder)
				{
					ionholder = Commands->Get_ID(poker);
					char ionguymsg[250];
					sprintf(ionguymsg,"%s please select the Ion Cannon Target.",Get_Player_Name(Commands->Find_Object(ionholder)));
					Send_Message_Team(1,255,204,0,ionguymsg);
					Commands->Create_2D_WAV_Sound("gdi_ion_select_target.wav");
					if (type == 1)//if the mapper decided to grant 10 sec beacons
					{
						Commands->Give_PowerUp(Commands->Find_Object(ionholder),"TCW_POW_Beacon_Nuke_10Sec",false);
					}
					else if (type == 2)//if the mapper decided to grant 60 sec beacons
					{
						Commands->Give_PowerUp(Commands->Find_Object(ionholder),"TCW_POW_Beacon_Nuke_60Sec",false);
					}
					Attach_Script_Once(Commands->Find_Object(ionholder),"tcw_I_Have_Ion_Cannon_Beacon","");
				}
			}
		}
		allowpoke = false; Commands->Enable_HUD_Pokable_Indicator(obj, false); Commands->Start_Timer(obj,this,10.0f,100101);//allow true set
	}
}
void tcw_Buy_Beacon_Ion::Custom(GameObject *obj, int message, int param, GameObject *sender)
{
	if (message == 100100)//the ion building was destroyed
	{
		if (param == 1)
		{
			ready = false;		charging = false;		allowpoke = false;
			if (ionholder)
			{
				Remove_Weapon(Commands->Find_Object(ionholder),"TCW_Weapon_IonCannon_10Sec");
				Remove_Weapon(Commands->Find_Object(ionholder),"TCW_Weapon_IonCannon_60Sec");
			}
		}
	}
	else if (message == 100101)//the guy died or left game, whatever
	{
		if (param == 1)
		{
			if (!Is_Building_Dead(Find_Object_By_Preset(1,"GDI_Ion_Control_Center")))
			{
				if (ready)
				{
					ionholder = 0;
					allowpoke = true; Commands->Enable_HUD_Pokable_Indicator(obj, true);
				}
			}
		}
	}
	else if (message == 100102)//successful ion strike done
	{
		if (param == 1)
		{
			if (!Is_Building_Dead(Find_Object_By_Preset(1,"GDI_Ion_Control_Center")))
			{
				ready = false;
				ionholder = 0;
				charging = true; Commands->Start_Timer(obj,this,30.0f,100100);
				allowpoke = true; Commands->Enable_HUD_Pokable_Indicator(obj, true);
			}
		}
	}
}

void tcw_Spikemap_Get_CaptureGuy::Created(GameObject *obj)
{
	// This script is for buying a Engineer or Saboteur for free on maps that have only spikes
	// It should be sticked on some pokable object
	allowpoke = true; Commands->Enable_HUD_Pokable_Indicator(obj, true);
	type = Get_Int_Parameter("Type");
}
void tcw_Spikemap_Get_CaptureGuy::Poked(GameObject *obj, GameObject *poker)
{
	if (allowpoke)
	{
		if (type == 0)
		{
			if (!Is_Building_Dead(Find_Building(0,BuildingConstants::TYPE_SOLDIER_FACTORY)))
			{
				if (Commands->Get_Player_Type(poker) == type)
				{
					if (Get_Object_Count(0,"TCW_Nod_Saboteur") < 1)
					{
						Change_Character(poker,"TCW_Nod_Saboteur");
					}
				}
			}
		}
		else if (type == 1)
		{
			if (!Is_Building_Dead(Find_Building(1,BuildingConstants::TYPE_SOLDIER_FACTORY)))
			{
				if (Commands->Get_Player_Type(poker) == type)
				{
					if (Get_Object_Count(1,"TCW_GDI_Engineer") < 1)
					{
						Change_Character(poker,"TCW_GDI_Engineer");
					}
				}
			}
		}
		allowpoke = false; Commands->Enable_HUD_Pokable_Indicator(obj, false); Commands->Start_Timer(obj,this,5.0f,100100);
	}
}
void tcw_Spikemap_Get_CaptureGuy::Timer_Expired(GameObject *obj, int number)
{
	if (number == 100100)
	{
		allowpoke = true; Commands->Enable_HUD_Pokable_Indicator(obj, true);
	}
}
void tcw_Spikemap_Get_CaptureGuy::Register_Auto_Save_Variables()
{
	Auto_Save_Variable(&allowpoke,sizeof(allowpoke),1);
	Auto_Save_Variable(&type,sizeof(type),1);
}

void tcw_Death_Blowup_Building::Killed(GameObject *obj, GameObject *shooter)
{
	int type = Get_Int_Parameter("Type");
	const char *building = Get_Parameter("Building_Name");
	Commands->Apply_Damage(Find_Building_By_Name(type,building),99999.0f,"C4",shooter);
}

void tcw_zone_teleport_random_id::Created(GameObject *obj)
{
	targetid1 = Get_Int_Parameter("ID1");
	targetid2 = Get_Int_Parameter("ID2");
	targetid3 = Get_Int_Parameter("ID3");
	tele = true;
}
void tcw_zone_teleport_random_id::Entered(GameObject *obj, GameObject *enter)
{
	if (tele)
	{
		if (!Get_Vehicle(enter))
		{
			tele = false; Commands->Start_Timer(obj,this,3.0f,100);
			int random = Commands->Get_Random_Int(1,3);
			if (random == 1)
			{
				GameObject *gotoObject;
				gotoObject = Commands->Find_Object(targetid1);
				Vector3 gotoLoc = Commands->Get_Position(gotoObject);
				Commands->Set_Position(enter,gotoLoc);
			}
			else if (random == 2)
			{
				GameObject *gotoObject;
				gotoObject = Commands->Find_Object(targetid2);
				Vector3 gotoLoc = Commands->Get_Position(gotoObject);
				Commands->Set_Position(enter,gotoLoc);
			}
			else if (random == 3)
			{
				GameObject *gotoObject;
				gotoObject = Commands->Find_Object(targetid3);
				Vector3 gotoLoc = Commands->Get_Position(gotoObject);
				Commands->Set_Position(enter,gotoLoc);
			}
		}
	}
}
void tcw_zone_teleport_random_id::Timer_Expired(GameObject *obj, int number)
{
	if (number == 100)
	{
		tele = true;
	}
}
void tcw_zone_teleport_random_id::Register_Auto_Save_Variables()
{
	Auto_Save_Variable(&targetid1,sizeof(targetid1),1);
	Auto_Save_Variable(&targetid2,sizeof(targetid1),2);
	Auto_Save_Variable(&targetid3,sizeof(targetid1),3);
	Auto_Save_Variable(&tele,sizeof(tele),4);
}

void tcw_dm_map_tech3::Created(GameObject *obj)//no limits
{
	//no limitations on map
}
void tcw_dm_map_tech2::Created(GameObject *obj)//no commando's
{
	Hide_Preset_By_Name(1,"TCW_GDI_Commando",true);
	Hide_Preset_By_Name(1,"TCW_GDI_Commando_Low",true);
	Hide_Preset_By_Name(0,"TCW_Nod_Commando",true);
	Hide_Preset_By_Name(0,"TCW_Nod_Commando_Low",true);
}
void tcw_dm_map_tech1::Created(GameObject *obj)//no snipers, shadows and commando's
{
	Hide_Preset_By_Name(1,"TCW_GDI_Commando",true);
	Hide_Preset_By_Name(1,"TCW_GDI_Commando_Low",true);
	Hide_Preset_By_Name(1,"TCW_GDI_Sniper",true);
	Hide_Preset_By_Name(1,"TCW_GDI_Sniper_Low",true);
	Hide_Preset_By_Name(0,"TCW_Nod_Commando",true);
	Hide_Preset_By_Name(0,"TCW_Nod_Commando_Low",true);
	Hide_Preset_By_Name(0,"TCW_Nod_Shadow",true);
	Hide_Preset_By_Name(0,"TCW_Nod_Shadow_Low",true);
}

void tcw_destroyed_send_custom::Destroyed(GameObject *obj)
{
	int msg = Get_Int_Parameter("Message");		int id = Get_Int_Parameter("SendID");	int prm = Get_Int_Parameter("Param");
	Commands->Send_Custom_Event(obj,Commands->Find_Object(id),msg,prm,0);
}

void tcw_test::Created(GameObject *obj)
{
	Console_Input("msg script created");
}


ScriptRegistrant<tcw_test> tcw_test_Registrant("tcw_test","");
ScriptRegistrant<tcw_destroyed_send_custom> tcw_destroyed_send_custom_Registrant("tcw_destroyed_send_custom","Message=1000:int,SendID=1000:int,Param=1:int");
ScriptRegistrant<tcw_dm_map_tech1> tcw_dm_map_tech1_Registrant("tcw_dm_map_tech1","");
ScriptRegistrant<tcw_dm_map_tech2> tcw_dm_map_tech2_Registrant("tcw_dm_map_tech2","");
ScriptRegistrant<tcw_dm_map_tech3> tcw_dm_map_tech3_Registrant("tcw_dm_map_tech3","");
ScriptRegistrant<tcw_zone_teleport_random_id> tcw_zone_teleport_random_id_Registrant("tcw_zone_teleport_random_id","ID1=1:int,ID2=2:int,ID3=3:int");
ScriptRegistrant<tcw_Death_Blowup_Building> tcw_Death_Blowup_Building_Registrant("tcw_Death_Blowup_Building","Type=0:int,Building_Name=TCW:string");
ScriptRegistrant<tcw_Spikemap_Get_CaptureGuy> tcw_Spikemap_Get_CaptureGuy_Registrant("tcw_Spikemap_Get_CaptureGuy","Type=0:int");
ScriptRegistrant<tcw_Buy_Beacon_Ion> tcw_Buy_Beacon_Ion_Registrant("tcw_Buy_Beacon_Ion","Type=2:int");
ScriptRegistrant<tcw_Enable_Refill> tcw_Enable_Refill_Registrant("tcw_Enable_Refill","");
ScriptRegistrant<tcw_There_Must_Be_Engineer> tcw_There_Must_Be_Engineer_Registrant("tcw_There_Must_Be_Engineer","");
ScriptRegistrant<tcw_Tiberium_Deposit_New> tcw_Tiberium_Deposit_New_Registrant("tcw_Tiberium_Deposit_New","");
ScriptRegistrant<tcw_Tiberium_Harvester_New> tcw_Tiberium_Harvester_New_Registrant("tcw_Tiberium_Harvester_New","");
ScriptRegistrant<tcw_Tiberium_Field_New> tcw_Tiberium_Field_New_Registrant("tcw_Tiberium_Field_New","Zonetype=0:int");
ScriptRegistrant<tcw_Map_Intro> tcw_Map_Intro_Registrant("tcw_Map_Intro","Red=1:int,Green=1:int,Blue=1:int,Intro1=Line1:string,Intro2=Line2:string,Intro3=Line3:string,Intro4=Line4:string,Intro5=Line5:string");
ScriptRegistrant<tcw_Set_Spike_Team_Created> tcw_Set_Spike_Team_Created_Registrant("tcw_Set_Spike_Team_Created","Team=0:int");
ScriptRegistrant<tcw_Custom_Win_Game_Credits> tcw_Custom_Win_Game_Credits_Registrant("tcw_Custom_Win_Game_Credits","");
ScriptRegistrant<tcw_Point_Trickle> tcw_Point_Trickle_Registrant("tcw_Point_Trickle","Points=1:int,Delay=2.0:float");
ScriptRegistrant<tcw_tiberium_spike_points> tcw_tiberium_spike_points_Registrant("tcw_tiberium_spike_points","");
ScriptRegistrant<tcw_Tiberium_Deposit> tcw_Tiberium_Deposit_Registrant("tcw_Tiberium_Deposit","Deposit_Message:int");
ScriptRegistrant<tcw_Tiberium_Field> tcw_Tiberium_Field_Registrant("tcw_Tiberium_Field","Cash:int,Time:float,TimerNum:int,Collected_Preset:string,Collected_Preset_Distance:float,Collected_Message:int,Nod_Preset_Green=TCW_Nod_Harvester_Player_Green:string,GDI_Preset_Green=TCW_GDI_Harvester_Player_Green:string,Nod_Preset_Blue=TCW_Nod_Harvester_Player_Blue:string,GDI_Preset_Blue=TCW_GDI_Harvester_Player_Blue:string,StartHarvest:int,StopHarvest:int");
ScriptRegistrant<tcw_Credit_Trickle> tcw_Credit_Trickle_Registrant("tcw_Credit_Trickle","Credits=1:int,Delay=2.0:float");
ScriptRegistrant<tcw_i_can_capture_spike> tcw_i_can_capture_spike_Registrant("tcw_i_can_capture_spike","");
ScriptRegistrant<tcw_tiberium_spike_capture> tcw_tiberium_spike_capture_Registrant("tcw_tiberium_spike_capture","Spike_ID=123:int");
ScriptRegistrant<tcw_tiberium_spike> tcw_tiberium_spike_Registrant("tcw_tiberium_spike","");
ScriptRegistrant<tcw_Tiberium_Harvester> tcw_Tiberium_Harvester_Registrant("tcw_Tiberium_Harvester","Collected_Message:int,Refinery_Message:int,Cash_Limit:int,Cash_Type:int,Entire_Team:int");