/*	Renegade Scripts.dll
	Copyright 2011 Tiberian Technologies

	This file is part of the Renegade scripts.dll
	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
	the terms of the GNU General Public License as published by the Free
	Software Foundation; either version 2, or (at your option) any later
	version. See the file COPYING for more details.
	In addition, an exemption is given to allow Run Time Dynamic Linking of this code with any closed source module that does not contain code covered by this licence.
	Only the source code to the module(s) containing the licenced code has to be released.
*/
#include "General.h"
#include "scripts.h"
#include "engine_tt.h"
#include "engine.h"
#include "BuildingGameObjDef.h"
#include "VehicleGameObjDef.h"
#include "z_nod_invasion.h"
#include "BaseControllerClass.h"
#include "GameObjManager.h"
//255,204,0 = gdi yellow


void z_ninv_MissionStart::Created(GameObject *obj)
{
	play = false;
	Commands->Start_Timer(obj,this,25.0f,101);
	Commands->Start_Timer(obj,this,30.0f,102);
	Commands->Start_Timer(obj,this,35.0f,103);
	Commands->Start_Timer(obj,this,40.0f,104);
	Commands->Start_Timer(obj,this,45.0f,105);
	Commands->Start_Timer(obj,this,50.0f,106);
	Commands->Start_Timer(obj,this,420.0f,107);//initialize mission timers, play=true
}
void z_ninv_MissionStart::Timer_Expired(GameObject *obj, int number)
{
	if (number == 101)
	{
		Send_Message(255,204,0,"Good afternoon Commanders");
		Commands->Create_2D_WAV_Sound("incmsg.wav");
	}
	else if (number == 102)
	{
		Send_Message(255,204,0,"The Brotherhood of Nod is inbound!");
		Commands->Create_2D_WAV_Sound("incmsg.wav");
	}
	else if (number == 103)
	{
		Send_Message(255,204,0,"We have exactly 7 minutes to protect our base by setting up defenses.");
		Commands->Create_2D_WAV_Sound("incmsg.wav");
	}
	else if (number == 104)
	{
		Send_Message(255,204,0,"Protect the civilians at all cost!");
		Commands->Create_2D_WAV_Sound("incmsg.wav");
	}
	else if (number == 105)
	{
		Send_Message(255,204,0,"Survive for 45 minutes, then we will send in reinforcements.");
		Commands->Create_2D_WAV_Sound("incmsg.wav");
	}
	else if (number == 106)
	{
		Send_Message(255,204,0,"Good luck Commanders.");
		Commands->Create_2D_WAV_Sound("incmsg.wav");
	}

	else if (number == 107)//init mission timers
	{
		play = true;
		Send_Message(255,204,0,"Mission Timer Initializing: 45 minutes remaining.");
		Commands->Create_2D_WAV_Sound("beep.wav");
		Commands->Start_Timer(obj,this,2700.0f,201);//end all spawners + start endgame checks
		Commands->Start_Timer(obj,this,2400.0f,202);//5 mins remaining
		Commands->Start_Timer(obj,this,2100.0f,203);//10 mins remaining
		Commands->Start_Timer(obj,this,1800.0f,204);//15 mins remaining
		Commands->Start_Timer(obj,this,1500.0f,205);//20 mins remaining
		Commands->Start_Timer(obj,this,1200.0f,206);//25 mins remaining
		Commands->Start_Timer(obj,this,900.0f,207);//30 mins remaining
		Commands->Start_Timer(obj,this,600.0f,208);//35 mins remaining
		Commands->Start_Timer(obj,this,300.0f,209);//40 mins remaining
		
		//lol enable bots:
		Commands->Enable_Spawner(100113,1);
		Commands->Enable_Spawner(100119,1);
		Commands->Enable_Spawner(100114,1);
		Commands->Enable_Spawner(100115,1);
		Commands->Enable_Spawner(100117,1);
		Commands->Enable_Spawner(100123,1);
		Commands->Enable_Spawner(100124,1);
		Commands->Enable_Spawner(100125,1);
		Commands->Enable_Spawner(100130,1);
		Commands->Enable_Spawner(100086,1);
		Commands->Enable_Spawner(100087,1);
		Commands->Enable_Spawner(100088,1);
		Commands->Enable_Spawner(100089,1);
		Commands->Enable_Spawner(100090,1);
		Commands->Enable_Spawner(100092,1);
		Commands->Enable_Spawner(100091,1);
		Commands->Enable_Spawner(100093,1);
		Commands->Enable_Spawner(100094,1);
		Commands->Enable_Spawner(100095,1);
		Commands->Enable_Spawner(100096,1);
		Commands->Enable_Spawner(100097,1);
		Commands->Enable_Spawner(100098,1);
		Commands->Enable_Spawner(100099,1);
		Commands->Enable_Spawner(100100,1);
		Commands->Enable_Spawner(100101,1);
		Commands->Enable_Spawner(100102,1);
		Commands->Enable_Spawner(100103,1);
		Commands->Enable_Spawner(100104,1);
		Commands->Enable_Spawner(100105,1);
		Commands->Enable_Spawner(100106,1);
		Commands->Enable_Spawner(100107,1);
		Commands->Enable_Spawner(100108,1);
		Commands->Enable_Spawner(100109,1);
		Commands->Enable_Spawner(100110,1);
		Commands->Enable_Spawner(100126,1);
		Commands->Enable_Spawner(100127,1);
		Commands->Enable_Spawner(100131,1);
		Commands->Enable_Spawner(100132,1);
		Commands->Enable_Spawner(100133,1);
		Commands->Enable_Spawner(100134,1);
		Commands->Enable_Spawner(100135,1);
		Commands->Enable_Spawner(100122,1);
		Commands->Enable_Spawner(100129,1);
		Commands->Enable_Spawner(100116,1);
		Commands->Enable_Spawner(100120,1);
		Commands->Enable_Spawner(100128,1);
		Commands->Enable_Spawner(100118,1);
		Commands->Enable_Spawner(100121,1);

		if (play)
		{
			Commands->Start_Timer(obj,this,333.0f,301);
			Commands->Start_Timer(obj,this,338.0f,302);
			Commands->Start_Timer(obj,this,335.0f,303);
			Commands->Start_Timer(obj,this,331.0f,304);
		}
	}
	else if (number == 301)
	{
		if (play)
		{
			if (The_Game()->Get_Current_Players() > 1)
			{
				//south
				GameObject *dropobj1 = Commands->Find_Object(100154);
				Vector3 pos1 = Commands->Get_Position(dropobj1);
				GameObject *object1 = Commands->Create_Object("Invisible_Object",pos1);
				Commands->Set_Facing(object1,70.000f);
				Commands->Attach_Script(object1,"JFW_Cinematic","z_ninv_noddrop_01.txt");

				GameObject *dropobj2 = Commands->Find_Object(100155);
				Vector3 pos2 = Commands->Get_Position(dropobj2);
				GameObject *object2 = Commands->Create_Object("Invisible_Object",pos2);
				Commands->Set_Facing(object2,10.000f);
				Commands->Attach_Script(object2,"JFW_Cinematic","z_ninv_noddrop_04.txt");

				GameObject *dropobj3 = Commands->Find_Object(100156);
				Vector3 pos3 = Commands->Get_Position(dropobj3);
				GameObject *object3 = Commands->Create_Object("Invisible_Object",pos3);
				Commands->Set_Facing(object3,90.000f);
				Commands->Attach_Script(object3,"JFW_Cinematic","z_ninv_noddrop_06.txt");

				GameObject *dropobj4 = Commands->Find_Object(100157);
				Vector3 pos4 = Commands->Get_Position(dropobj4);
				GameObject *object4 = Commands->Create_Object("Invisible_Object",pos4);
				Commands->Set_Facing(object4,120.000f);
				Commands->Attach_Script(object4,"JFW_Cinematic","z_ninv_noddrop_05.txt");

				GameObject *dropobj5 = Commands->Find_Object(100158);
				Vector3 pos5 = Commands->Get_Position(dropobj5);
				GameObject *object5 = Commands->Create_Object("Invisible_Object",pos5);
				Commands->Set_Facing(object5,120.000f);
				Commands->Attach_Script(object5,"JFW_Cinematic","z_ninv_noddrop_02.txt");

				GameObject *dropobj6 = Commands->Find_Object(100159);
				Vector3 pos6 = Commands->Get_Position(dropobj6);
				GameObject *object6 = Commands->Create_Object("Invisible_Object",pos6);
				Commands->Set_Facing(object6,120.000f);
				Commands->Attach_Script(object6,"JFW_Cinematic","z_ninv_noddrop_03.txt");
				Commands->Create_2D_WAV_Sound("airraid.wav");
				Send_Message(255,255,255,"Incoming Nod Aircraft");
			}
			Commands->Start_Timer(obj,this,180.0f,301);
		}
	}
	else if (number == 302)
	{
		if (play)
		{
			if (The_Game()->Get_Current_Players() > 1)
			{
				//west
				GameObject *dropobj7 = Commands->Find_Object(100160);
				Vector3 pos7 = Commands->Get_Position(dropobj7);
				GameObject *object7 = Commands->Create_Object("Invisible_Object",pos7);
				Commands->Set_Facing(object7,10.000f);
				Commands->Attach_Script(object7,"JFW_Cinematic","z_ninv_noddrop_01.txt");

				GameObject *dropobj8 = Commands->Find_Object(100161);
				Vector3 pos8 = Commands->Get_Position(dropobj8);
				GameObject *object8 = Commands->Create_Object("Invisible_Object",pos8);
				Commands->Set_Facing(object8,76.000f);
				Commands->Attach_Script(object8,"JFW_Cinematic","z_ninv_noddrop_04.txt");

				GameObject *dropobj9 = Commands->Find_Object(100162);
				Vector3 pos9 = Commands->Get_Position(dropobj9);
				GameObject *object9 = Commands->Create_Object("Invisible_Object",pos9);
				Commands->Set_Facing(object9,90.000f);
				Commands->Attach_Script(object9,"JFW_Cinematic","z_ninv_noddrop_06.txt");

				GameObject *dropobj10 = Commands->Find_Object(100163);
				Vector3 pos10 = Commands->Get_Position(dropobj10);
				GameObject *object10 = Commands->Create_Object("Invisible_Object",pos10);
				Commands->Set_Facing(object10,220.000f);
				Commands->Attach_Script(object10,"JFW_Cinematic","z_ninv_noddrop_05.txt");

				GameObject *dropobj11 = Commands->Find_Object(100164);
				Vector3 pos11 = Commands->Get_Position(dropobj11);
				GameObject *object11 = Commands->Create_Object("Invisible_Object",pos11);
				Commands->Set_Facing(object11,125.000f);
				Commands->Attach_Script(object11,"JFW_Cinematic","z_ninv_noddrop_02.txt");

				GameObject *dropobj12 = Commands->Find_Object(100165);
				Vector3 pos12 = Commands->Get_Position(dropobj12);
				GameObject *object12 = Commands->Create_Object("Invisible_Object",pos12);
				Commands->Set_Facing(object12,180.000f);
				Commands->Attach_Script(object12,"JFW_Cinematic","z_ninv_noddrop_03.txt");
				Commands->Create_2D_WAV_Sound("airraid.wav");
				Send_Message(255,255,255,"Incoming Nod Aircraft");
			}
			Commands->Start_Timer(obj,this,180.0f,302);
		}
	}
	else if (number == 303)
	{
		if (play)
		{
			if (The_Game()->Get_Current_Players() > 1)
			{
				//north
				GameObject *dropobj1 = Commands->Find_Object(100166);
				Vector3 pos1 = Commands->Get_Position(dropobj1);
				GameObject *object1 = Commands->Create_Object("Invisible_Object",pos1);
				Commands->Set_Facing(object1,330.000f);
				Commands->Attach_Script(object1,"JFW_Cinematic","z_ninv_noddrop_01.txt");

				GameObject *dropobj2 = Commands->Find_Object(100167);
				Vector3 pos2 = Commands->Get_Position(dropobj2);
				GameObject *object2 = Commands->Create_Object("Invisible_Object",pos2);
				Commands->Set_Facing(object2,140.000f);
				Commands->Attach_Script(object2,"JFW_Cinematic","z_ninv_noddrop_04.txt");

				GameObject *dropobj3 = Commands->Find_Object(100168);
				Vector3 pos3 = Commands->Get_Position(dropobj3);
				GameObject *object3 = Commands->Create_Object("Invisible_Object",pos3);
				Commands->Set_Facing(object3,180.000f);
				Commands->Attach_Script(object3,"JFW_Cinematic","z_ninv_noddrop_06.txt");

				GameObject *dropobj4 = Commands->Find_Object(100169);
				Vector3 pos4 = Commands->Get_Position(dropobj4);
				GameObject *object4 = Commands->Create_Object("Invisible_Object",pos4);
				Commands->Set_Facing(object4,170.000f);
				Commands->Attach_Script(object4,"JFW_Cinematic","z_ninv_noddrop_05.txt");

				GameObject *dropobj5 = Commands->Find_Object(100170);
				Vector3 pos5 = Commands->Get_Position(dropobj5);
				GameObject *object5 = Commands->Create_Object("Invisible_Object",pos5);
				Commands->Set_Facing(object5,190.000f);
				Commands->Attach_Script(object5,"JFW_Cinematic","z_ninv_noddrop_02.txt");

				GameObject *dropobj6 = Commands->Find_Object(100171);
				Vector3 pos6 = Commands->Get_Position(dropobj6);
				GameObject *object6 = Commands->Create_Object("Invisible_Object",pos6);
				Commands->Set_Facing(object6,180.000f);
				Commands->Attach_Script(object6,"JFW_Cinematic","z_ninv_noddrop_03.txt");
				Commands->Create_2D_WAV_Sound("airraid.wav");
				Send_Message(255,255,255,"Incoming Nod Aircraft");
			}
			Commands->Start_Timer(obj,this,120.0f,303);
		}
	}
	else if (number == 304)
	{
		if (play)
		{
			if (The_Game()->Get_Current_Players() > 1)
			{
				//east
				GameObject *dropobj1 = Commands->Find_Object(100172);
				Vector3 pos1 = Commands->Get_Position(dropobj1);
				GameObject *object1 = Commands->Create_Object("Invisible_Object",pos1);
				Commands->Set_Facing(object1,359.000f);
				Commands->Attach_Script(object1,"JFW_Cinematic","z_ninv_noddrop_01.txt");

				GameObject *dropobj2 = Commands->Find_Object(100173);
				Vector3 pos2 = Commands->Get_Position(dropobj2);
				GameObject *object2 = Commands->Create_Object("Invisible_Object",pos2);
				Commands->Set_Facing(object2,110.000f);
				Commands->Attach_Script(object2,"JFW_Cinematic","z_ninv_noddrop_04.txt");

				GameObject *dropobj3 = Commands->Find_Object(100174);
				Vector3 pos3 = Commands->Get_Position(dropobj3);
				GameObject *object3 = Commands->Create_Object("Invisible_Object",pos3);
				Commands->Set_Facing(object3,230.000f);
				Commands->Attach_Script(object3,"JFW_Cinematic","z_ninv_noddrop_06.txt");

				GameObject *dropobj4 = Commands->Find_Object(100175);
				Vector3 pos4 = Commands->Get_Position(dropobj4);
				GameObject *object4 = Commands->Create_Object("Invisible_Object",pos4);
				Commands->Set_Facing(object4,190.000f);
				Commands->Attach_Script(object4,"JFW_Cinematic","z_ninv_noddrop_05.txt");

				GameObject *dropobj5 = Commands->Find_Object(100176);
				Vector3 pos5 = Commands->Get_Position(dropobj5);
				GameObject *object5 = Commands->Create_Object("Invisible_Object",pos5);
				Commands->Set_Facing(object5,10.000f);
				Commands->Attach_Script(object5,"JFW_Cinematic","z_ninv_noddrop_02.txt");

				GameObject *dropobj6 = Commands->Find_Object(100177);
				Vector3 pos6 = Commands->Get_Position(dropobj6);
				GameObject *object6 = Commands->Create_Object("Invisible_Object",pos6);
				Commands->Set_Facing(object6,120.000f);
				Commands->Attach_Script(object6,"JFW_Cinematic","z_ninv_noddrop_03.txt");
				Commands->Create_2D_WAV_Sound("airraid.wav");
				Send_Message(255,255,255,"Incoming Nod Aircraft");
			}
			Commands->Start_Timer(obj,this,180.0f,304);
		}
	}

	else if (number == 200)
	{
		Console_Input("amsg Mission Accomplished");
		Console_Input("win 1");
	}
	else if (number == 201)
	{
		play = false;
		//lol disable bots:
		Commands->Enable_Spawner(100113,0);
		Commands->Enable_Spawner(100119,0);
		Commands->Enable_Spawner(100114,0);
		Commands->Enable_Spawner(100115,0);
		Commands->Enable_Spawner(100117,0);
		Commands->Enable_Spawner(100123,0);
		Commands->Enable_Spawner(100124,0);
		Commands->Enable_Spawner(100125,0);
		Commands->Enable_Spawner(100130,0);
		Commands->Enable_Spawner(100086,0);
		Commands->Enable_Spawner(100087,0);
		Commands->Enable_Spawner(100088,0);
		Commands->Enable_Spawner(100089,0);
		Commands->Enable_Spawner(100090,0);
		Commands->Enable_Spawner(100092,0);
		Commands->Enable_Spawner(100091,0);
		Commands->Enable_Spawner(100093,0);
		Commands->Enable_Spawner(100094,0);
		Commands->Enable_Spawner(100095,0);
		Commands->Enable_Spawner(100096,0);
		Commands->Enable_Spawner(100097,0);
		Commands->Enable_Spawner(100098,0);
		Commands->Enable_Spawner(100099,0);
		Commands->Enable_Spawner(100100,0);
		Commands->Enable_Spawner(100101,0);
		Commands->Enable_Spawner(100102,0);
		Commands->Enable_Spawner(100103,0);
		Commands->Enable_Spawner(100104,0);
		Commands->Enable_Spawner(100105,0);
		Commands->Enable_Spawner(100106,0);
		Commands->Enable_Spawner(100107,0);
		Commands->Enable_Spawner(100108,0);
		Commands->Enable_Spawner(100109,0);
		Commands->Enable_Spawner(100110,0);
		Commands->Enable_Spawner(100126,0);
		Commands->Enable_Spawner(100127,0);
		Commands->Enable_Spawner(100131,0);
		Commands->Enable_Spawner(100132,0);
		Commands->Enable_Spawner(100133,0);
		Commands->Enable_Spawner(100134,0);
		Commands->Enable_Spawner(100135,0);
		Commands->Enable_Spawner(100122,0);
		Commands->Enable_Spawner(100129,0);
		Commands->Enable_Spawner(100116,0);
		Commands->Enable_Spawner(100120,0);
		Commands->Enable_Spawner(100128,0);
		Commands->Enable_Spawner(100118,0);
		Commands->Enable_Spawner(100121,0);
		Send_Message(255,204,0,"Well done commanders. We survived!");
		Commands->Create_2D_WAV_Sound("beep.wav");
		Commands->Start_Timer(obj,this,120.0f,200);//end win in 2mins endgame
	}
	else if (number == 202)
	{
		Send_Message(255,204,0,"Warning: 5 minutes remaining.");
		Commands->Create_2D_WAV_Sound("beep.wav");
	}
	else if (number == 203)
	{
		Send_Message(255,204,0,"Warning: 10 minutes remaining.");
		Commands->Create_2D_WAV_Sound("beep.wav");
	}
	else if (number == 204)
	{
		Send_Message(255,204,0,"Warning: 15 minutes remaining.");
		Commands->Create_2D_WAV_Sound("beep.wav");
	}
	else if (number == 205)
	{
		Send_Message(255,204,0,"Warning: 20 minutes remaining.");
		Commands->Create_2D_WAV_Sound("beep.wav");
	}
	else if (number == 206)
	{
		Send_Message(255,204,0,"Warning: 25 minutes remaining.");
		Commands->Create_2D_WAV_Sound("beep.wav");
	}
	else if (number == 207)
	{
		Send_Message(255,204,0,"Warning: 30 minutes remaining.");
		Commands->Create_2D_WAV_Sound("beep.wav");
	}
	else if (number == 208)
	{
		Send_Message(255,204,0,"Warning: 35 minutes remaining.");
		Commands->Create_2D_WAV_Sound("beep.wav");
	}
	else if (number == 209)
	{
		Send_Message(255,204,0,"Warning: 40 minutes remaining.");
		Commands->Create_2D_WAV_Sound("beep.wav");
	}
}

void z_ninv_Civilian::Killed(GameObject *obj, GameObject *shooter)
{
	Commands->Create_2D_WAV_Sound("civkilled.wav");
	Send_Message(255,255,255,"Civilian Killed");
}

void z_ninv_CivCount::Created(GameObject *obj)
{
	alive = Get_Int_Parameter("Civs");
}
void z_ninv_CivCount::Custom(GameObject *obj, int message, int param, GameObject *sender)
{
	if (message == 1000)
	{
		if (param == 1)
		{
			alive--;
			if (alive == 1)
			{
				Send_Message(255,204,0,"Be careful. Civilians are being killed. If the last one dies you will lose!");
			}
			else if (alive == 0)
			{
				Console_Input("amsg Mission Failed. All Civilians were killed.");
				Commands->Start_Timer(obj,this,5.0f,100);//fail
				Commands->Start_Timer(obj,this,7.5f,101);//end
			}
		}
	}
}
void z_ninv_CivCount::Timer_Expired(GameObject *obj, int number)
{
	if (number == 100)
	{
		Send_Message(255,255,255,"Your mission is a failure.");
		Commands->Create_2D_WAV_Sound("missionfailed.wav");
	}
	else if (number == 101)
	{
		Console_Input("win 0");
	}
}
void z_ninv_CivCount::Register_Auto_Save_Variables()
{
	Auto_Save_Variable(&alive,5,1);
}

void z_ninv_Buy_SamsiteSW::Created(GameObject *obj)
{
	funds = 0;
	Commands->Enable_HUD_Pokable_Indicator(obj,true);
}
void z_ninv_Buy_SamsiteSW::Poked(GameObject *obj, GameObject *poker)
{
	if (funds < 2500.0f)
	{
		if (Commands->Get_Money(poker) >= 500.0f)
		{
			funds = funds + 500.0f;
			char fundadded[250];
			const char *str = Get_Player_Name(poker);
			sprintf(fundadded,"%s added $500 to the South West Samsites fundpool. (Current: %g / %g)",str,funds,2500.0f);
			delete[] str;
			Send_Message(255,255,255,fundadded);
			Commands->Give_Money(poker,-500.0f,false);
		}
		else if (Commands->Get_Money(poker) < 500.0f)
		{
			char nomoney[100]; 
			sprintf(nomoney,"ppage %d Sorry you do not have enough money ($500) to add to the Samsites fundpool.",Get_Player_ID(poker));
			Console_Input(nomoney);
		}

		if (funds == 2500.0f)
		{
			Commands->Create_2D_WAV_Sound("building.wav");
			Commands->Start_Timer(obj,this,3.0f,166);
		}
	}
}
void z_ninv_Buy_SamsiteSW::Timer_Expired(GameObject *obj, int number)
{
	if (number == 166)
	{
		Vector3 pos1;		pos1.X = -33.731f;		pos1.Y = -53.145f;		pos1.Z = 8.546f;
		float facing1 = 0.0f;
		GameObject *ss1 = Commands->Create_Object("z_GDI_Sam_Site",pos1);
		Commands->Set_Facing(ss1,facing1);

		Vector3 pos2;		pos2.X = -30.532f;		pos2.Y = -47.349f;		pos2.Z = 8.497f;
		float facing2 = 0.0f;
		GameObject *ss2 = Commands->Create_Object("z_GDI_Sam_Site",pos2);
		Commands->Set_Facing(ss2,facing2);

		char msg[250];
		sprintf(msg,"The %s Samsites are now operational.","South West");
		Send_Message(255,255,255,msg);
		Commands->Destroy_Object(obj);
	}
}
void z_ninv_Buy_SamsiteSW::Register_Auto_Save_Variables()
{
	Auto_Save_Variable(&funds,5,1);
}

void z_ninv_Buy_SamsiteNE::Created(GameObject *obj)
{
	funds = 0;
	Commands->Enable_HUD_Pokable_Indicator(obj,true);
}
void z_ninv_Buy_SamsiteNE::Poked(GameObject *obj, GameObject *poker)
{
	if (funds < 2500.0f)
	{
		if (Commands->Get_Money(poker) >= 500.0f)
		{
			funds = funds + 500.0f;
			char fundadded[250];
			const char *str = Get_Player_Name(poker);
			sprintf(fundadded,"%s added $500 to the North East Samsites fundpool. (Current: %g / %g)",str,funds,2500.0f);
			delete[] str;
			Send_Message(255,255,255,fundadded);
			Commands->Give_Money(poker,-500.0f,false);
		}
		else if (Commands->Get_Money(poker) < 500.0f)
		{
			char nomoney[100]; 
			sprintf(nomoney,"ppage %d Sorry you do not have enough money ($500) to add to the Samsites fundpool.",Get_Player_ID(poker));
			Console_Input(nomoney);
		}

		if (funds == 2500.0f)
		{
			Commands->Create_2D_WAV_Sound("building.wav");
			Commands->Start_Timer(obj,this,3.0f,166);
		}
	}
}
void z_ninv_Buy_SamsiteNE::Timer_Expired(GameObject *obj, int number)
{
	if (number == 166)
	{
		Vector3 pos1;		pos1.X = 54.800f;		pos1.Y = 41.703f;		pos1.Z = 8.693f;
		float facing1 = 0.0f;
		GameObject *ss1 = Commands->Create_Object("z_GDI_Sam_Site",pos1);
		Commands->Set_Facing(ss1,facing1);

		Vector3 pos2;		pos2.X = 51.580f;		pos2.Y = 35.846f;		pos2.Z = 8.713f;
		float facing2 = 0.0f;
		GameObject *ss2 = Commands->Create_Object("z_GDI_Sam_Site",pos2);
		Commands->Set_Facing(ss2,facing2);

		char msg[250];
		sprintf(msg,"The %s Samsites are now operational.","North East");
		Send_Message(255,255,255,msg);
		Commands->Destroy_Object(obj);
	}
}
void z_ninv_Buy_SamsiteNE::Register_Auto_Save_Variables()
{
	Auto_Save_Variable(&funds,5,1);
}

void z_ninv_Buy_GuardtowerNE::Created(GameObject *obj)
{
	funds = 0;
	Commands->Enable_HUD_Pokable_Indicator(obj,true);
}
void z_ninv_Buy_GuardtowerNE::Poked(GameObject *obj, GameObject *poker)
{
	if (funds < 2500.0f)
	{
		if (Commands->Get_Money(poker) >= 500.0f)
		{
			funds = funds + 500.0f;
			char fundadded[250];
			const char *str = Get_Player_Name(poker);
			sprintf(fundadded,"%s added $500 to the North East Guard Tower fundpool. (Current: %g / %g)",str,funds,2500.0f);
			delete[] str;
			Send_Message(255,255,255,fundadded);
			Commands->Give_Money(poker,-500.0f,false);
		}
		else if (Commands->Get_Money(poker) < 500.0f)
		{
			char nomoney[100]; 
			sprintf(nomoney,"ppage %d Sorry you do not have enough money ($500) to add to the Guard Tower fundpool.",Get_Player_ID(poker));
			Console_Input(nomoney);
		}

		if (funds == 2500.0f)
		{
			Commands->Create_2D_WAV_Sound("building.wav");
			Commands->Start_Timer(obj,this,3.0f,166);
		}
	}
}
void z_ninv_Buy_GuardtowerNE::Timer_Expired(GameObject *obj, int number)
{
	if (number == 166)
	{
		Vector3 pos1;		pos1.X = 66.869f;		pos1.Y = 39.652f;		pos1.Z = 7.172f;
		float facing1 = 0.0f;
		GameObject *ss1 = Commands->Create_Object("z_GDI_GuardTower",pos1);
		Commands->Set_Facing(ss1,facing1);

		Vector3 pos2;		pos2.X = 54.206f;		pos2.Y = 49.450f;		pos2.Z = 7.172f;
		float facing2 = 0.0f;
		GameObject *ss2 = Commands->Create_Object("z_GDI_GuardTower",pos2);
		Commands->Set_Facing(ss2,facing2);

		char msg[250];
		sprintf(msg,"The %s Guard Towers are now operational.","North East");
		Send_Message(255,255,255,msg);
		Commands->Destroy_Object(obj);
	}
}
void z_ninv_Buy_GuardtowerNE::Register_Auto_Save_Variables()
{
	Auto_Save_Variable(&funds,5,1);
}

void z_ninv_Buy_GuardtowerSW::Created(GameObject *obj)
{
	funds = 0;
	Commands->Enable_HUD_Pokable_Indicator(obj,true);
}
void z_ninv_Buy_GuardtowerSW::Poked(GameObject *obj, GameObject *poker)
{
	if (funds < 2500.0f)
	{
		if (Commands->Get_Money(poker) >= 500.0f)
		{
			funds = funds + 500.0f;
			char fundadded[250];
			const char *str = Get_Player_Name(poker);
			sprintf(fundadded,"%s added $500 to the South West Guard Tower fundpool. (Current: %g / %g)",str,funds,2500.0f);
			delete[] str;
			Send_Message(255,255,255,fundadded);
			Commands->Give_Money(poker,-500.0f,false);
		}
		else if (Commands->Get_Money(poker) < 500.0f)
		{
			char nomoney[100]; 
			sprintf(nomoney,"ppage %d Sorry you do not have enough money ($500) to add to the Guard Tower fundpool.",Get_Player_ID(poker));
			Console_Input(nomoney);
		}

		if (funds == 2500.0f)
		{
			Commands->Create_2D_WAV_Sound("building.wav");
			Commands->Start_Timer(obj,this,3.0f,166);
		}
	}
}
void z_ninv_Buy_GuardtowerSW::Timer_Expired(GameObject *obj, int number)
{
	if (number == 166)
	{
		Vector3 pos1;		pos1.X = -32.288f;		pos1.Y = -60.183f;		pos1.Z = 7.096f;
		float facing1 = 0.0f;
		GameObject *ss1 = Commands->Create_Object("z_GDI_GuardTower",pos1);
		Commands->Set_Facing(ss1,facing1);

		Vector3 pos2;		pos2.X = -44.195f;		pos2.Y = -49.544f;		pos2.Z = 7.096f;
		float facing2 = 0.0f;
		GameObject *ss2 = Commands->Create_Object("z_GDI_GuardTower",pos2);
		Commands->Set_Facing(ss2,facing2);

		char msg[250];
		sprintf(msg,"The %s Guard Towers are now operational.","South West");
		Send_Message(255,255,255,msg);
		Commands->Destroy_Object(obj);
	}
}
void z_ninv_Buy_GuardtowerSW::Register_Auto_Save_Variables()
{
	Auto_Save_Variable(&funds,5,1);
}

ScriptRegistrant<z_ninv_Buy_GuardtowerSW> z_ninv_Buy_GuardtowerSW_Registrant("z_ninv_Buy_GuardtowerSW","");
ScriptRegistrant<z_ninv_Buy_GuardtowerNE> z_ninv_Buy_GuardtowerNE_Registrant("z_ninv_Buy_GuardtowerNE","");
ScriptRegistrant<z_ninv_Buy_SamsiteNE> z_ninv_Buy_SamsiteNE_Registrant("z_ninv_Buy_SamsiteNE","");
ScriptRegistrant<z_ninv_Buy_SamsiteSW> z_ninv_Buy_SamsiteSW_Registrant("z_ninv_Buy_SamsiteSW","");
ScriptRegistrant<z_ninv_CivCount> z_ninv_CivCount_Registrant("z_ninv_CivCount","Civs=6:int");
ScriptRegistrant<z_ninv_Civilian> z_ninv_Civilian_Registrant("z_ninv_Civilian","");
ScriptRegistrant<z_ninv_MissionStart> z_ninv_MissionStart_Registrant("z_ninv_MissionStart","");